use dataset2, clear

estimates use "mrswholesample"

genmrsvars
genmarshallandhicks

qui makealpha, wagevar(sp_lw) leisurevar(sp_lleis)

estimates use "ivreg_eulerresults"
matrix wholesampleresults = e(b)

if "$depvar" == "Z" {
    matrix sigmavar = wholesampleresults[1,"W"]
    local sigma = (1/sigmavar[1,1])+1
}
if "$depvar" == "W" {
    matrix sigmavar = wholesampleresults[1,"Z"]
    local sigma = (sigmavar[1,1]+1)
}

foreach var in h l c {

    qui centile M`var', centile(7.5 12.5)
    gen bdecM`var' = inrange(M`var',r(c_1),r(c_2))

    qui centile M`var', centile(22.5 27.5)
    gen lqM`var' = inrange(M`var',r(c_1),r(c_2))

    qui centile M`var', centile(47.5 52.5)
    gen medianM`var' = inrange(M`var',r(c_1),r(c_2))

    qui centile M`var', centile(72.5 77.5)
    gen uqM`var' = inrange(M`var',r(c_1),r(c_2))
	
	qui centile M`var', centile(87.5 92.5)
    gen udecM`var' = inrange(M`var',r(c_1),r(c_2))
}

*generate Frisch elasticities given assumption of additive separability
calcfrisch, sigma(1)
foreach var in h l c {
    foreach quant in bdec lq median uq udec {
        qui su F`var' if `quant'M`var'==1
        scalar `quant'F`var'_add = r(mean)
		qui su F`var'_IR if `quant'M`var'==1
        scalar `quant'F`var'_IR_add = r(mean)
    }
}

drop M uc ul ucc ull ucl term Fc Fl Fh Fc_IR Fl_IR Fh_IR riskaversion sigma

calcfrisch, sigma(`sigma')

qui gen concave = ucc<0 & ull<0 & term>0
*assert concave==1

foreach var in h l c {	
    foreach quant in bdec lq median uq udec {
        qui su M`var' if `quant'M`var'==1
        scalar `quant'M`var' = r(mean)
        qui su H`var' if `quant'M`var'==1
        scalar `quant'H`var' = r(mean)
        qui su F`var' if `quant'M`var'==1
        scalar `quant'F`var' = r(mean)
		qui su F`var'_IR if `quant'M`var'==1
        scalar `quant'F`var'_IR = r(mean)
    }
}

