clear all 
set more off
capture log close
pause on

log using "testcobbdouglas.txt", text replace
do define_macros
do define_programs

set seed 435403

use dataset2, clear

runmrs

*Number of instruments
global l = e(exexog_ct)

test lc==-sp_lleis==1
global wholesampletstat = r(chi2) 

gen newdepvar = sp_lw - lc + sp_lleis
xi: reg newdepvar e1 e2minusone e3 $mrs_cntrl if sp_employed==1
predict u1 if e(sample), resid
predict sp_lwhat if e(sample), xb

reg sp_lleis e1 e2minusone e3 $mrs_cntrl $instlist if sp_employed==1 
predict u2 if e(sample), resid
predict sp_lleishat if e(sample), xb

reg lc e1 e2minusone e3 $mrs_cntrl $instlist if sp_employed==1 
predict u3 if e(sample), resid
predict lchat if e(sample), xb

qui count if e(sample)
global N = r(N)

replace u1 = u1*($N/($N-$l))^0.5
replace u2 = u2*($N/($N-$l))^0.5
replace u3 = u3*($N/($N-$l))^0.5

keep if e(sample)==1

save tempdata_CD, replace

capture program drop testboot_wild
program testboot_wild, rclass

	use tempdata_CD, clear 
	tempvar sp_lw_star lc_star sp_lleis_star
	tempvar rand v
	
	gen `rand' = runiform()
	gen `v'    = 2*(`rand'>0.5)-1
	
	sort `rand', stable 
	bys uniqcuid (intno): replace `v' = `v'[1]
	
	qui gen double `sp_lleis_star' = sp_lleishat + u2*`v'
	qui gen double `lc_star'       = lchat + u3*`v'
	
	qui gen double `sp_lw_star'    = -`sp_lleis_star' +  `lc_star' + sp_lwhat + u1*`v'

	xi: ivreg2 `sp_lw_star' e1 e2minusone e3 $mrs_cntrl (`sp_lleis_star'  `lc_star'  = $instlist) if sp_employed==1, fuller(1)
	test `lc_star'==-`sp_lleis_star'==1

	return scalar tstat = r(chi2) 

end

simulate tstat = r(tstat), reps(999): testboot_wild

gen abststat = abs(tstat)
qui count 
local B= r(N)
gen abswholesampletstat = abs($wholesampletstat)

qui count if abststat>abswholesampletstat 
gen pvalue = r(N)/`B'
su pvalue

erase tempdata_CD.dta

log close
