clear all 
set more off
capture log close
pause on

log using "testces.txt", text replace
do define_macros
do define_programs

set seed 435403

use dataset2, clear

runmrs

test lc==-sp_lleis
global wholesampletstat = r(chi2) 

qui gen sp_lleisminuslc = lc - sp_lleis
xi: ivreg2 sp_lw e1 e2minusone e3 $mrs_cntrl (sp_lleisminuslc = $instlist) if sp_employed==1, fuller(1) 
predict u1 if e(sample), resid
predict sp_lwhat if e(sample), xb

global phi = _b[sp_lleisminuslc]

*Number of instruments
global l = e(exexog_ct)

reg sp_lleis e1 e2minusone e3 $mrs_cntrl $instlist if sp_employed==1 
predict u2 if e(sample), resid
predict sp_lleishat if e(sample), xb

reg lc e1 e2minusone e3 $mrs_cntrl $instlist if sp_employed==1 
predict u3 if e(sample), resid
predict lchat if e(sample), xb

qui count if e(sample)
global N = r(N)

*rescale residuals
replace u2 = u2*($N/($N-$l))^0.5
replace u3 = u3*($N/($N-$l))^0.5

keep if e(sample)==1

save tempdata, replace

capture program drop testboot_wild
program testboot_wild, rclass

	use tempdata, clear 
	tempvar sp_lw_star lc_star sp_lleis_star
	tempvar rand v
	
	qui gen double `rand' = runiform()
	qui gen double `v'    = 2*(`rand'>=0.5)-1
	
	*do this to cluster the standard errors
	sort `rand', stable 
	bys uniqcuid (intno): replace `v' = `v'[1]

	qui gen double `sp_lleis_star' = sp_lleishat + u2*`v'
	qui gen double `lc_star'       = lchat + u3*`v'
	
	qui gen double `sp_lw_star'    = $phi*(`lc_star'  - `sp_lleis_star')  + u1*`v'
	
	xi: ivreg2 `sp_lw_star' e1 e2minusone e3 $mrs_cntrl (`sp_lleis_star'  `lc_star'  = $instlist) if sp_employed==1, fuller(1)
	test `lc_star' ==-`sp_lleis_star'  
	return scalar tstat = r(chi2) 

end

simulate tstat = r(tstat), reps(999): testboot_wild
*bootstrap p-value
gen abststat = abs(tstat)
qui count 
local B= r(N)
gen abswholesampletstat = abs($wholesampletstat)

qui count if abststat>abswholesampletstat 
gen pvalue = r(N)/`B'
su pvalue

erase tempdata.dta

log close
