#delimit ;
set more off;

/*imports data from the CPI*/
/*saves deflator, called by master*/

clear;
insheet using "$datadir/cpi.csv", comma;

local i = 1;
foreach month in jan feb mar apr may jun jul aug sep oct nov dec {;
    rename `month' cpi`i';
    local i = `i' +1;
};

reshape long cpi, i(year) j(mo);
rename year yr;
sort yr mo;
drop if cpi==.;
replace cpi = (cpi/cpi[_N])*100;

/*same as qtr1*/
recode mo (1/3 = 1) (4/6 = 2) (7/9 = 3) (10/12 = 4), generate(qtr);

recode mo (1/3 = 1) (4/6 = 2) (7/9 = 3) (10/12 = 4), generate(qtr1);
recode mo (11 12 1 = 1) (2/4 = 2) (5/7 = 3) (8/10 = 4), generate(qtr2);
recode mo (12 1 2 = 1) (3/5 = 2) (6/8 = 3) (9/11 = 4), generate(qtr3);

/*change years to correspond with year of interview*/
gen yr1 = yr;
gen yr2 = yr;
replace yr2 = yr+1 if mo==11|mo==12;
gen yr3 = yr;
replace yr3 = yr+1 if mo==12;

/*calculate quarterly averages (for "quarters defined by interview windows)*/
preserve;
collapse (mean) cpi, by(yr1 qtr1);
rename cpi cpi_qtr1;
save "$datadir/deflator1", replace;
gen cpi_qtr1forint5 = cpi_qtr1[_n+3];
drop cpi_qtr1;
save "$datadir/deflator1_forint5", replace;
restore;

preserve;
collapse (mean) cpi, by(yr2 qtr2);
rename cpi cpi_qtr2;
save "$datadir/deflator2", replace;
gen cpi_qtr2forint5 = cpi_qtr2[_n+3];
drop cpi_qtr2;
save "$datadir/deflator2_forint5", replace;
restore;

preserve;
collapse (mean) cpi, by(yr3 qtr3);
rename cpi cpi_qtr3;
save "$datadir/deflator3", replace;
gen cpi_qtr3forint5 = cpi_qtr3[_n+3];
drop cpi_qtr3;
save "$datadir/deflator3_forint5", replace;
restore;

/*just for merging with dataset*/
gen spend_yr = yr;
gen spend_mo = mo;

gen int_mo = mo;
gen int_yr = yr;

sort int_yr int_mo;
gen cpi_ann = (cpi[_n-1]+cpi[_n-2]+cpi[_n-3]+cpi[_n-4]+cpi[_n-5]+cpi[_n-6]+cpi[_n-7]+cpi[_n-8]+cpi[_n-9]+cpi[_n-10]+cpi[_n-11]+cpi[_n-12])/12;

preserve;
keep int_mo int_yr cpi_ann;
save "$datadir/deflator_ann", replace;
restore;

save "$datadir/deflator", replace;








