capture log close
use mrseuler_boot, clear
merge 1:1 _n using elasticities_cf
drop _merge

drop probitconverged
des
local varcount = r(k)

matrix tabresults = J(`varcount',5,-999)

estimates use "mrswholesample"
matrix b = e(b)
matnames b
local mrsvarlist "`r(c)'"

estimates use "ivreg_eulerresults"
matrix euler_b = e(b)
matnames euler_b
local eulervarlist "`r(c)'"

rename mrs__cons mrs_constant
rename euler__cons euler_constant

local i = 1
foreach var in `mrsvarlist' {
    local varname = substr("`var'",2,.)
    if "`varname'"=="_cons" {
        local varname "constant"
    }
	local varname "mrs_`varname'"

    qui su `varname'
    matrix tabresults[`i',1] = r(sd)
    qui centile `varname', centile(2.5 97.5 0.5 99.5)
    matrix tabresults[`i',2] = r(c_1)
    matrix tabresults[`i',3] = r(c_2)
    matrix tabresults[`i',4] = r(c_3)
    matrix tabresults[`i',5] = r(c_4)

    local i = `i' + 1
}

#delimit ;
foreach var of varlist $psi_mrs_cntrl mrs_theta mrs_phi {;
    qui su `var';
    matrix tabresults[`i',1] = r(sd);
    qui centile `var', centile(2.5 97.5 0.5 99.5);
    matrix tabresults[`i',2] = r(c_1);
    matrix tabresults[`i',3] = r(c_2);
    matrix tabresults[`i',4] = r(c_3);
    matrix tabresults[`i',5] = r(c_4);
    local i = `i' + 1;
};
#delimit cr

foreach var in `eulervarlist' {
    local varname = substr("`var'",2,.)
    if "`varname'"=="_cons" {
        local varname "constant"
    }
	local varname "euler_`varname'"
    qui su `varname'
    matrix tabresults[`i',1] = r(sd)
    qui centile `varname', centile(2.5 97.5 0.5 99.5)
    matrix tabresults[`i',2] = r(c_1)
    matrix tabresults[`i',3] = r(c_2)
    matrix tabresults[`i',4] = r(c_3)
    matrix tabresults[`i',5] = r(c_4)

    local i = `i' + 1
}

#delimit ;
foreach var of varlist euler_sigma bdecMc lqMc medianMc uqMc udecMc bdecHc lqHc medianHc uqHc udecHc bdecFc lqFc medianFc uqFc udecFc
bdecMh lqMh medianMh uqMh udecMh bdecHh lqHh medianHh uqHh udecHh bdecFh lqFh medianFh uqFh udecFh
bdecMl lqMl medianMl uqMl udecMl bdecHl lqHl medianHl uqHl udecHl bdecFl lqFl medianFl uqFl udecFl
bdecFc_IR lqFc_IR medianFc_IR uqFc_IR udecFc_IR
bdecFh_IR lqFh_IR medianFh_IR uqFh_IR udecFh_IR
bdecFl_IR lqFl_IR medianFl_IR uqFl_IR udecFl_IR
bdecFc_add lqFc_add medianFc_add uqFc_add udecFc_add 
bdecFh_add lqFh_add medianFh_add uqFh_add udecFh_add
bdecFl_add lqFl_add medianFl_add uqFl_add udecFl_add
bdecFc_IR_add lqFc_IR_add medianFc_IR_add uqFc_IR_add udecFc_IR_add 
bdecFh_IR_add lqFh_IR_add medianFh_IR_add uqFh_IR_add udecFh_IR_add 
bdecFl_IR_add lqFl_IR_add medianFl_IR_add uqFl_IR_add udecFl_IR_add {;
    qui su `var';
    matrix tabresults[`i',1] = r(sd);
    qui centile `var', centile(2.5 97.5 0.5 99.5);
    matrix tabresults[`i',2] = r(c_1);
    matrix tabresults[`i',3] = r(c_2);
    matrix tabresults[`i',4] = r(c_3);
    matrix tabresults[`i',5] = r(c_4);
    local i = `i' + 1;
};


matrix rownames tabresults = `mrsvarlist' $psi_mrs_cntrl theta phi `eulervarlist' sigma
bdecMc lqMc medianMc uqMc udecMc bdecHc lqHc medianHc uqHc udecHc bdecFc lqFc medianFc uqFc udecFc
bdecMh lqMh medianMh uqMh udecMh bdecHh lqHh medianHh uqHh udecHh bdecFh lqFh medianFh uqFh udecFh
bdecMl lqMl medianMl uqMl udecMl bdecHl lqHl medianHl uqHl udecHl bdecFl lqFl medianFl uqFl udecFl
bdecFc_IR lqFc_IR medianFc_IR uqFc_IR udecFc_IR
bdecFh_IR lqFh_IR medianFh_IR uqFh_IR udecFh_IR
bdecFl_IR lqFl_IR medianFl_IR uqFl_IR udecFl_IR
bdecFc_add lqFc_add medianFc_add uqFc_add udecFc_add 
bdecFh_add lqFh_add medianFh_add uqFh_add udecFh_add
bdecFl_add lqFl_add medianFl_add uqFl_add udecFl_add
bdecFc_IR_add lqFc_IR_add medianFc_IR_add uqFc_IR_add udecFc_IR_add 
bdecFh_IR_add lqFh_IR_add medianFh_IR_add uqFh_IR_add udecFh_IR_add 
bdecFl_IR_add lqFl_IR_add medianFl_IR_add uqFl_IR_add udecFl_IR_add;
#delimit cr

matrix colnames tabresults = se 5percentlb 5percentub 1percentlb 1percentub

log using "mrseulerbootresults.txt", text replace
matrix list tabresults
log close


