!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module bisection
	implicit none


	contains
	
	double precision function rtbis(func,x1,x2,ifail)
	implicit none 

	integer ifail, j, JMAX
    double precision dx, f, fmid, func,x1,x2,xacc, xmid
    external func
    
	parameter (JMAX=100)

	xacc	= epsilon(dx)
	!xacc = 1.d-10
  fmid	=func(x2)
  f		=func(x1)
  if(f*fmid.ge.0.d0) then 
			!write (10,*) 'f,fmid,x1,x2 ', f,fmid,x1,x2 
			write (10,*) 'root must be bracketed in rtbis'
		ifail = 1

		fmid = func(x2)
			return
	else
			ifail = 0
	endif


    if(f.lt.0.d0) then
        rtbis	= x1
        dx		= x2 - x1
    else
        rtbis	= x2
        dx		= x1 - x2
    endif

    do j=1,JMAX
        dx		= dx * 0.5d0
        xmid	= rtbis + dx
        fmid	= func(xmid)
        if(fmid.le.0.d0) rtbis = xmid
        if(abs(dx).lt.xacc .or. abs(fmid).lt.xacc) return
	enddo

	write (10,*) 'too many bisections '

	end function rtbis
!____________________________________________________________

	double precision function rtbisres(func,x1,x2,ifail)
	implicit none 

	integer ifail, j, JMAX
    double precision dx, f, fmid, func,x1,x2,xacc, xmid
    external func
    
	parameter (JMAX=100)

	xacc	= epsilon(dx)
	!xacc  = 1.d-10
    f		=func(x1)
    fmid	=func(x2)
    if(f*fmid.ge.0.d0) then 
			write (10,*) 'root must be bracketed in rtbis reserv',f,fmid,x1,x2
			ifail = 1
			fmid = func(x2)
			f = func(x1)
			
			return
	else
			ifail = 0
	endif


    if(f.lt.0.d0) then
        rtbisres	= x1
        dx		= x2 - x1
    else
        rtbisres	= x2
        dx		= x1 - x2
    endif

    do j=1,JMAX
        dx		= dx * 0.5d0
        xmid	= rtbisres + dx
        fmid	= func(xmid)
        if(fmid.le.0.d0) rtbisres = xmid
        if(abs(dx).lt.xacc .or. abs(fmid).lt.xacc) return
	enddo

	write (10,*) 'too many bisections '

	end function rtbisres
!____________________________________________________________



    SUBROUTINE zbrac(func,x1,x2,succes)
    implicit none

	integer j, NTRY, succes
    double precision f1,f2, x1,x2,func,FACTOR
    external func

	parameter (FACTOR=1.6,NTRY=50)

    
	f1		= func(x1)
    f2		= func(x2)
    succes	= 1
    do j=1,NTRY

        if(f1*f2.lt.0.d0) return

        if(abs(f1).lt.abs(f2))then
          x1 = x1+FACTOR*(x1-x2)
          f1 = func(x1)
        else

          x2 = x2+FACTOR*(x2-x1)
		  f2 = func(x2)
        endif
	enddo

    succes = 0

    return
    end subroutine zbrac





	  double precision function golden(ax,bx,cx,f,xmin)
	  
	  double precision ax,bx,cx,xmin,f,R,C, tol
      
	  EXTERNAL f

      PARAMETER (R=0.61803399d0, C=1.d0-R, tol=1.d-3)
      
	  double precision f1,f2,x0,x1,x2,x3

      x0=ax
      x3=cx

      if(abs(cx-bx).gt.abs(bx-ax))then
        x1=bx
        x2=bx+C*(cx-bx)
      else
        x2=bx
        x1=bx-C*(bx-ax)
      endif

      f1=f(x1)
      f2=f(x2)

1     if(abs(x3-x0).gt.tol*(abs(x1)+abs(x2)))then

        if(f2.lt.f1)then
          x0=x1
          x1=x2
          x2=R*x1+C*x3

          f1=f2
          f2=f(x2)
        else
          x3=x2
          x2=x1
          x1=R*x2+C*x0
          f2=f1
          f1=f(x1)
        endif
      goto 1
      endif
      
	  if(f1.lt.f2)then
        golden=f1
        xmin=x1
      else
        golden=f2
        xmin=x2
      endif

      return

      end function golden


      SUBROUTINE sortdp(n,arr)
      INTEGER n,M,NSTACK
      double precision arr(n)
      PARAMETER (M=7, NSTACK=50)
      INTEGER i,ir,j,jstack,k,l,istack(NSTACK)
      double precision a,temp
      jstack=0
      l=1
      ir=n
      
901   if(ir-l.lt.M) then
        do j=l+1,ir
            a=arr(j)
            do i=j-1,l,-1
                if(arr(i).le.a)goto 902
                arr(i+1)=arr(i)
            enddo
            i=l-1
902         arr(i+1)=a
        enddo
        
        if(jstack.eq.0)return
        
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      
      else
        k=(l+ir)/2
        temp=arr(k)
        arr(k)=arr(l+1)
        arr(l+1)=temp
        
        if(arr(l).gt.arr(ir))then
          temp=arr(l)
          arr(l)=arr(ir)
          arr(ir)=temp
        endif

        if(arr(l+1).gt.arr(ir))then
          temp=arr(l+1)
          arr(l+1)=arr(ir)
          arr(ir)=temp
        endif

        if(arr(l).gt.arr(l+1))then
          temp=arr(l)
          arr(l)=arr(l+1)
          arr(l+1)=temp
        endif

        i=l+1
        j=ir
        a=arr(l+1)
903     continue
        i=i+1
        if(arr(i).lt.a)goto 903
        
904     continue
        j=j-1
        if(arr(j).gt.a)goto 904
        
        if(j.lt.i)goto 905
        temp=arr(i)
        arr(i)=arr(j)
        arr(j)=temp
        goto 903
        
905     arr(l+1)=arr(j)
        arr(j)=a
        jstack=jstack+2

        if(jstack.gt.NSTACK) write (10,*) 'NSTACK too small in sort'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      
      goto 901
      
      END subroutine sortdp
      
      SUBROUTINE sort(n,arr)
      INTEGER n,M,NSTACK
      integer arr(n)
      PARAMETER (M=7, NSTACK=50)
      INTEGER i,ir,j,jstack,k,l,istack(NSTACK)
      integer a,temp
      
      
      jstack=0
      l=1
      ir=n
      
901   if(ir-l.lt.M) then
        do j=l+1,ir
            a=arr(j)
            do i=j-1,l,-1
                if(arr(i).le.a)goto 902
                arr(i+1)=arr(i)
            enddo
            i=l-1
902         arr(i+1)=a
        enddo
        
        if(jstack.eq.0)return
        
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      
      else
        k=(l+ir)/2
        temp=arr(k)
        arr(k)=arr(l+1)
        arr(l+1)=temp
        
        if(arr(l).gt.arr(ir))then
          temp=arr(l)
          arr(l)=arr(ir)
          arr(ir)=temp
        endif

        if(arr(l+1).gt.arr(ir))then
          temp=arr(l+1)
          arr(l+1)=arr(ir)
          arr(ir)=temp
        endif

        if(arr(l).gt.arr(l+1))then
          temp=arr(l)
          arr(l)=arr(l+1)
          arr(l+1)=temp
        endif

        i=l+1
        j=ir
        a=arr(l+1)
903     continue
        i=i+1
        if(arr(i).lt.a)goto 903
        
904     continue
        j=j-1
        if(arr(j).gt.a)goto 904
        
        if(j.lt.i)goto 905
        temp=arr(i)
        arr(i)=arr(j)
        arr(j)=temp
        goto 903
        
905     arr(l+1)=arr(j)
        arr(j)=a
        jstack=jstack+2

        if(jstack.gt.NSTACK) write (10,*) 'NSTACK too small in sort'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      
      goto 901
      
      END subroutine sort

end module bisection

!_______________________________________________
