subroutine partner(xx, ffxx, nxx)
use inputs
use params		!reads in parameters from params.inp
use wageproc	!defines the Markov process for primary and secondary earners using quadrature  
use assetgrid !defines bounds on the cash-in-hand dimension
use subrout   !transfers current state between routines (old common)
use equations !subroutines for solving optimisation step in recursion
use reservat  !solving for reservation cash-in-hand (cash level above which choose not to work
use simulate  !for simulating the model once a solution is found
use banner
use statistics
use summaryindex
use makutility

implicit none

integer a, ier, ifail, i,j, nn,	node, nodebit,nodeas,  p, t, w, xm, xtonon, xtoemp, ww, pp, &
    istart, iend, istart2, iend2, ri
integer::nxx, wold

double precision cons, connon, ediff,diff2, maxspd, minpt,&
resass,  value, valuenon, valnonold, leisemp, & 
valold, withemp, withnon, withnonold, time1a, time2a,time3a, total

double precision, allocatable :: asscut_tmp(:), valemp_tmp(:), withemp_tmp(:), leisemp_tmp(:), valun_tmp(:), withun_tmp(:)
double precision, allocatable :: asscut_tmptot(:), valemp_tmptot(:), withemp_tmptot(:), leisemp_tmptot(:), valun_tmptot(:), withun_tmptot(:)

double precision:: xx(nxx), ffxx(nxx)

INTEGER(2) hour, minute, second,hund

character(len=4)   :: cid


double precision:: minres,value2,withemp2,valuenon2,withnon2, check

time1a = 0.d0 
time2a = 0.d0
time3a = 0.d0 
!call cpu_time( time1a )  

if ( id .lt. 10 ) then
     write(cid,'(i1)') id
else if ( id .lt. 100 ) then
     write(cid,'(i2)') id
end if
     

!1-------------ALLOCATE MEMORY-----------------------------------------------------------------------------

if (firstcall.eq.1) then 

        call reading2( ier )
        if (ier.ne.0) then 
            write (*,*) 'trouble reading data in id ', ier, id
        endif

        call allocate_wageproc_perm(ier)
        if (ier.ne.0) then
	        write (*,*) 'trouble in allocating wage arrays in id ', ier, id
        endif

        call allocate_wageproc_temp(ier)
        if (ier.ne.0) then
	        write (*,*) 'trouble in allocating temp wage arrays in id ', ier, id
        endif

        call allocate_partproc_temp(ier)
        if (ier.ne.0) then
	        write (*,*) 'trouble in allocating temp partner arrays in id ', ier, id
        endif
        call allocate_simulate(ier)
        if (ier.ne.0) then
	        write (*,*) 'trouble inallocating simul arrays in id ', ier, id
        endif
        

       
endif

!2--------------OPEN FILES-----------------------------------------------------------------------------



if (id.eq.0) then 
    !open (unit=20, file ='../Outputs/sims.out')
	open (unit=21, file ='../Outputs/GridPointsVisited.out')
	open (unit=9996, file ='../Outputs/CornersUmim.out')
	open (unit=9997, file ='../Outputs/CornersUmax.out')
	open (unit=9998, file ='../Outputs/CornersEmim.out')
	open (unit=9999, file ='../Outputs/CornersEmax.out')
    
endif


!3-------------INITIALIZED VALUES---------------------------------------------------------------

!!!!!!!!!!!!!!!!parameters!!!!!!!!!!!!!!!!!!!
do i=1,npar
     modpars(i)  = xx(i) !grid search
enddo



chi        = modpars(1)
theta      = modpars(2)
phi        = modpars(3)




kidalpha0   = modpars(5) 
deltaper1   = modpars(6) 
iniggap     = modpars(7) 




oleta0 = modpars(8)                
oleta1 = modpars(9)
alpha1 = 1.d0           ! is the default for no diminishing returns to human capital. 

costworking = modpars(10)
mu = modpars(11)

age1  = modpars(12)      	
age2  = modpars(13)      	




!!!!!!!!!!!variables!!!!!!!!!!!
begnosims = 1	 
weignosims = 0



totcon= 0.0d0 
toteis= 0.d0
totpay= 0.0d0 
totsav= 0.0d0
totfixed= 0.0d0
totpaypart= 0.0d0
varcon= 0.d0
varpay= 0.d0 
nonlin= 0.d0
nonlin2= 0.d0
nonlin3=-10000.d0
nonlin4=-10000.d0
nonlin5=10000.d0
contnonlin2= 0.d0
partip= 0.d0
totexp= 0.d0
totexpun=0.d0
partkid=0.d0
partkid1=0.d0
partkid2=0.d0
partkid1elas=0.d0
partkid2elas=0.d0
partnotyet=0.d0
partnever=0.d0
p3to18=0.d0
contyrskids=0
contyrskids1=0
contyrskids2=0
contyrskids1elas=0
contyrskids2elas=0
cont3to18=0
partbef=0.d0
partaft=0.d0
partnomot = 0.d0 
nomot = 0
nonotyet=0
nonever=0
contbefaft = 0
avnumperout=0.0d0
avnumbyexit=0.0d0
avnoofexit=0.0d0
avnoexitreenty=0.0d0
meduration=0.0d0

iwage = 0.d0 
icons=0.d0
ileis=0.d0
ipart = 0.d0 

iwbefaft = -100.d0 
iiwbefaft = -100.d0 
inumbyexit = 0 
iinumbyexit = 0
totgappay = 0.d0 
totgappart = 0.d0 
    
visitemp = 0
visitnon = 0
!visitexpvalue= 0 
countcornerUmin=0
countcornerUmax=0
countcornerEmin=0
countcornerEmax=0
	 	
frpart = 0
frparthighw = 0 
counthighw = 0
frpartloww = 0
countloww = 0

payfr = 0.d0 
payhighf = 0.d0 
paylowf = 0.d0 
partkidtmp =0.d0 
partkidtmp2=0.d0 
partkidtmp3=0.d0
contyrskidstmp =0
contyrskidstmp2 =0
contyrskidstmp3 =0
countall = 0 

noviolations = 0 
nononviolations = 0

simulando=0

maxpartcash=-10000000.d0





!4------------SOLVING MODEL----------------------------------------------------------------

MPI_N = ntotal/nproc 
itemp = ntotal - MPI_N*nproc
if (itemp>0) MPI_N=MPI_N+1	!!!!ntotal NOT equal to mpi_n*nproc if itemp>0
istart = id*MPI_N +1
iend = min((id+1)*MPI_N,ntotal)


MPI_N2 = ntotal2/nproc 
itemp = ntotal2 - MPI_N2*nproc
if (itemp>0) MPI_N2=MPI_N2+1	!!!!ntotal2 NOT equal to mpi_n*nproc if itemp>0
istart2 = id*MPI_N2 +1
iend2 = min((id+1)*MPI_N2, ntotal2)



allocate (asscut_tmp(MPI_N), valemp_tmp(MPI_N2), withemp_tmp(MPI_N2),leisemp_tmp(MPI_N2), valun_tmp(MPI_N2), withun_tmp(MPI_N2) )
allocate(asscut_tmptot(MPI_N*NPROC), withun_tmptot(MPI_N2*NPROC), leisemp_tmptot(MPI_N2*NPROC) )    
allocate(valun_tmptot(MPI_N2*NPROC), valemp_tmptot(MPI_N2*NPROC),  withemp_tmptot(MPI_N2*NPROC) )



do ki=1,notypes


	if(ki.le.3)then
		alfa       = modpars(4)+alfaL
	elseif(ki.gt.3.AND.ki.le.6)then
		alfa       = modpars(4)+alfaM
	else
		alfa       = modpars(4)+alfaH
	endif
	
    agekid = kid(ki)*(1-quarter) + quarter*((kid(ki)-1)*4 +1)

    if(ki==1)then
        begnosims = 1  !adding number at j=1 to begin number
    else
        begnosims = 1 + int(sum(propkid(1:ki-1))*nosims)
    endif
    weignosims =  int(sum(propkid(1:ki))*nosims)	
   
	
	if(ID.eq.0)write(*,*)ki,begnosims,weignosims
	

call modpar
! set up wage process: or rather individual productivity process



call markovwagepr




!the fixed cost of work is age dependent and evaluated as a proportion of 
!mean earnings (but the actual fixed cost is independent of earnings)								 
do t=1,nt
	fixed(t) =  infants(t)  + costworking
enddo
		
! set up grid of possible asset values 
call bounds



!set all solutions to wild
		valun			= -1.d100
		withun		= -1.d100
  	    valemploy	= -1.d100
		withemploy = -1.d100
        leisemploy = -1.d100
		asscut		= -1.d100
		asscut  = -1.d10
	
! loop backwards in time



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

wold = 0						 
					
		
do t=nt+ret,1,-1   
	age   = t
	ageto = t+1
	if(ID==0)write(*,*)t

  
	 
    !BEFORE RETIREMENT!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    if (t.le.nt) then 
	! first solve for reservation asset stocks for each alpha 

        do ri=1,MPI_N
            asscut_tmp(ri) = -1.d10 
        enddo

		 finishasscut=0
         do ri= istart,iend
          
            sindex = inv_sumindex(nmindex,ri)   
            w=sindex(1)
            p=sindex(2)
            xm = sindex(3) 

           oldpar = -1.d0 
           oldparone = -1.d0 

           wold = w

		    wnode = w
            pnode = p
            part = pxw(p,t)

			xvalue = xm
			wage   = xw(w,t) * expvalue(xm,t) 

			solutiongrid=0
			
			call reserve2(resass)
			
			!find reservation asset stock: at what level of assets does the individual
			!stop working given the alph 
			asscut_tmp(ri-istart+1) = resass

	    enddo
        
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        call MPI_Barrier(MPI_COMM_WORLD,ierr)

        call MPI_AllGATHER(asscut_tmp(1),MPI_N,MPI_DOUBLE_PRECISION,&
                asscut_tmptot(1),MPI_N,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
        do ri=1,ntotal
	        asscut(ri,age)=asscut_tmptot(ri)

        enddo
        call MPI_Barrier(MPI_COMM_WORLD,ierr)
        
         
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        do ri=1,ntotal
	        sindex = inv_sumindex(nmindex,ri)   
            xvalue = sindex(3) 
            call gridnon(xvalue,ri,age) 
         
        enddo
    
        call MPI_Barrier(MPI_COMM_WORLD,ierr) 
        do ri=1,ntotal
	        sindex = inv_sumindex(nmindex,ri)   
            xvalue = sindex(3) 
	       if (asscut(ri,age).gt.alow(xvalue,age)+xtol) then
    	        call grid(xvalue,ri,age)		 !grid below reserv ass

	        else	
		        asscut(ri,age) = alow(xvalue,age) - 1.d100
	        endif
        enddo
        call MPI_Barrier(MPI_COMM_WORLD,ierr)
  
    else
			!xanon() is not contingent on states from t=nt+1 to nt+ret.All states share 
			!the same grid in the retirement period
            call gridnon(1,1,age)
			
			 
    endif   
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
	!now loop to solve at each point in the state space
	!should distinguish whether retired or not 
	
	solutiongrid=1
	
	
    do ri=1,MPI_N2
            valemp_tmp(ri)  = -1.d10
            withemp_tmp(ri) = -1.d10
            valun_tmp(ri)   = -1.d10
            withun_tmp(ri)  = -1.d10
            leisemp_tmp(ri) = -1.d10
     enddo

     if (t.le.nt) then 
     
		wold = 0
		finishasscut=1
        do ri=istart2,iend2

			call cpu_time( time1a ) 
			
			flag=0

            sindex2 = inv_sumindex(nmindex2,ri)            

            w=sindex2(1)
            p=sindex2(2)
            xm = sindex2(3) 
            a = sindex2(4)

           if (wold.eq.w ) then 
                oldpar = -1.d0 
                oldparone = -1.d0 
           endif

            wold = w

			anode=a               
            wnode = w
            pnode = p
            part = pxw(p,t)

		    xvalue = xm

			if(t.lt.nt)then
				xtoemp = max(mapping( t,xm, 1, max(hours*hoursdecision,hoursfix)),1) !assume min hours to define minincome
				xtonon = max(mapping( t,xm, 0, 0.d0),1)
			else
				xtoemp = 1
				xtonon = 1
			endif

            wage      = xw(w,t) *  expvalue(xm,t) 
			
		    nodeas = sumindex(nmindex,(/w,p,xm/))

            !state variable for cash-in-hand if working

	        node		= ri 
	        partcash	= xawork(a,nodeas, age) 
			

			
			

			!1--now solve for the value function if employed 
	        if (asscut(nodeas,age).gt.alow(xvalue,age)+xtol.and.  &
		 	        partcash +wage*max(hours*hoursdecision,hoursfix)-fixed(t) + mininc(xtoemp,t).gt.0.d0) then


        			call valemp(value,withemp,leisemp)  !this solves for the optimal value function
					
														!at this point in the state space
 					
 				
 					
					valemp_tmp(ri-istart2+1)  = value
					withemp_tmp(ri-istart2+1) = withemp
                    leisemp_tmp(ri-istart2+1) = leisemp
					
				
                          
            else
                    value = 0.d0 
                     withemp = 0.d0 
                     leisemp = 0.d0          
					    							
			endif 			
			
		    !2--now solve for the value function if unemployed 
		    if (asscut(nodeas,age).le.ahigh(age)) then 
					
				    partcash = xanon(a,nodeas, age)

				    if (partcash+mininc(xtonon,age).lt.-1.d-8) then !not work gives neg consumption

					    write (*,*) 'problem in non solution ',ID
					    

				    elseif (partcash+mininc(xtonon,age).ge.0.d0) then
					

						
						    call valnon(valuenon,withnon)
						    !valnon solves for consumption (ie connon=withnon)
						       
		 
						    withnonold = withnon
						    valnonold  = valuenon

						    valun_tmp(ri-istart2+1)  = valuenon
						    connon			         = withnon
						    withun_tmp(ri-istart2+1) = withnon
							
				
				    endif

			
		    endif


    enddo !end loop for wage  !end of ri loop

    
  
	!DURING RETIREMENT!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	       
	else  !solve retirement problem where loop only over partner income
	    
	        do p=1,pnw
	            pnode = p
				w = 1
				xm = 1
	            !nodeas = sumindex(nmindex,(/w,p,xm/))

	            do a=1,na
	    	        partcash = xanon(a,1,age)

					call valnon(valuenon,withnon)
					!valnon solves for consumption (ie connon=withnon)
					node = sumindex(nmindex2,(/w,p,xm,a/))
					valun(node, age)  = valuenon
					withun(node, age) = withnon
                   				
	            enddo
	        enddo
	    endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
if(age.le.nt)then  !for t=nt+1,nt+ret already saved in valun

    valun_tmptot=-1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(valun_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,valun_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,ntotal2
	    valun(ri,age)=valun_tmptot(ri)
    enddo

    withun_tmptot=-1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(withun_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,withun_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,ntotal2
	    withun(ri,age)=withun_tmptot(ri)
    enddo

    valemp_tmptot = -1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(valemp_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,valemp_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,ntotal2
	    valemploy(ri,age)=valemp_tmptot(ri)
    enddo

    withemp_tmptot=-1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(withemp_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,withemp_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,ntotal2
	    withemploy(ri,age)=withemp_tmptot(ri)
    enddo

    leisemp_tmptot=-1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(leisemp_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,leisemp_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,ntotal2
	    leisemploy(ri,age)=leisemp_tmptot(ri)
    enddo
    call MPI_Barrier(MPI_COMM_WORLD,ierr)

	
endif



enddo !end loop on age, backwards


!5---------------SIMULATE-----------------------------------------------------------------------
simulando=1

visitemp = 0
visitnon = 0


call empsim				 !simulation routine once the numerical solution is found


enddo !end of loop over ki


deallocate (asscut_tmp, valemp_tmp, withemp_tmp, valun_tmp, withun_tmp )
deallocate(asscut_tmptot, withun_tmptot )
deallocate(valun_tmptot, valemp_tmptot, withemp_tmptot, leisemp_tmptot )


!6---------------STATISTICS-----------------------------------------------------------------------


call simulstats

!calibration error!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
do j=1,npar
    ffxx(j) = calibstats(j)
enddo
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	

666  continue

9999 format (5(3x,e14.6))
9998 format (5(2x,e14.6))

7888 format (e14.6)
8888 format (E14.6, 2(2x,I4), 3(3x,e14.6))
8887 format ( 3(I6,2X), e16.6 )   

RETURN


900 continue

end subroutine partner



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
