module reservat

!routine for solving for the reservation level of cash in hand
!we are assuming this is unique. In practice, I check it is unique
!under certainty (requires discount rate a bit greater than interest rate)
!and then say uncertainty convexifies the problem so will still be unique
!(perhaps a bit shaky!)

use params
use subrout
use equations
use bisection

implicit none

double precision, private:: diff, differ, differ2, leis, minres, maxres,  olddiff, value, &
	valuenon, withnon, withemp,	leisemp, leisemp2, value2, value3, valuenon2, valuenon3, &
	withnon2, withemp2, withemp3, withnon3

integer, private:: dummy, xtonon, xtoemp

	contains

!__________________________________________________________________________
subroutine reserve2(resass)

	double precision const, resass

	integer i, ifail

	reschk = 1
	



	if(age.lt.nt)then
		xtonon = max(mapping(age,xvalue,0,0.d0),1)
		xtoemp = max(mapping(age,xvalue,1,hours),1)    
		
		!have put zero in here which means no increase in experience. This is the worst case
	    !for the individual - would expect some experience increasse that could borrow against
	else

		xtonon =1
		xtoemp =1
	endif

	minres = max( -mininc(xtonon,age) + minass, alow(xvalue,age) ) 
	maxres = ahigh(age)

	   
	!at minres, want to be working
	partcash = minres
 	call valnon(valuenon2,withnon2)
	

    cash = partcash + wage*max(hours*hoursdecision,hoursfix) - fixed(age)
	if (cash + mininc(xtoemp,age).gt.0.d0) then 
		call valemp(value2,withemp2, leisemp2)								
	else
		value2 = -1.d10
	endif
	
			
	differ2 = value2 - valuenon2
	
	
	if (differ2.lt.0.d0) then  ! never working
		!write (*,*) 'not working at min ass', pnode, wnode,age
		resass = minres 
		return
	endif

	!at maxres, want to be unemployed
	partcash = maxres
	call valnon(valuenon,withnon)
		 
	cash = partcash+ wage*max(hours*hoursdecision,hoursfix) - fixed(age)
	if (cash + mininc(xtoemp,age).gt.0.d0 ) then 
		call valemp(value,withemp, leisemp)
		
	else
		value = -1.d14
	endif
	
			
	differ = value - valuenon
	
	if (differ.gt.0.d0) then  ! always working 
	!	write (*,*) 'always working: p, w, age ', pnode, wnode,age
		resass = ahigh(age) + 1.d14
		return
	endif

! bracketing the reservation asset stock (conditional on indivual state)
	ifail = 0
	resass = rtbisres(resfunc,minres,maxres,ifail)

    !write (10,*) 'ifail ', ifail
     
     if (ifail.eq.1) then 
	
		write (32,'(5i3,5f14.2)') age,pnode,wnode,xvalue,ifail,minres,maxres,differ2,differ,resass
		
		
        const = (maxres-minres)/499.d0
		do i=1,1 !500
			partcash = minres !const*dble(i) + minres   
			
			
			if (partcash + mininc(xtonon,age).gt.0.d0) then
				call valnon(valuenon2,withnon2)
			
				
				cash = partcash + wage*max(hours*hoursdecision,hoursfix) - fixed(age)
				if (cash + mininc(xtoemp,age).gt.0.d0) then 
					call valemp(value2,withemp2,leisemp2)
					
					diff = value2 - valuenon2

					if (diff*olddiff.lt.0.d0) dummy = dummy + 1

					olddiff = diff
					
					write (32,'(i4,6f14.4)') i,partcash, withemp2,  leisemp2,value2, withnon2, valuenon2
					
				 
					else 
						value2 = 0.d0
						valuenon2 = 0.d0
					endif
			 else 
			
				   value2 = 0.d0
				   valuenon2 = 0.d0

			 endif
			
						
		enddo

     
          
     endif
     

end subroutine reserve2

	double precision function resfunc(resass)

	implicit none
	double precision resass, valuenon, value, withemp, withnon, leis

		partcash = resass
		call valnon(valuenon,withnon)


		if(age.lt.nt)then
			xtoemp = max(mapping(age,xvalue,1,max(hours*hoursdecision,hoursfix) ),1)
		else
			xtoemp = 1
		endif

		cash = partcash + wage*max(hours*hoursdecision,hoursfix) - fixed(age)
		if (cash + mininc(xtoemp,age).gt.0.d0) then 
			call valemp(value,withemp,leis)
			
			resfunc = value - valuenon

		else !never working
		 	resfunc = -1.d5

		endif
			
	end function resfunc



end module reservat



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
