module simulate

!simulation routine using the numerical solution

use params
use wageproc
use assetgrid
use subrout
use consolve
use inputs
use equations

implicit none   
      
double precision, private:: assterm, cons,cons2,  differ, dum, experien, highun, hourswork, leis, logcon, &
	  logpay, lowun, ocons, oleis,oldcon, probhigh, rannum, saving, socsec, val, within

double precision logpart, mult,  totgappart, partkidtmp, partkidtmp2,partkidtmp3
   
double precision, allocatable :: avpart(:), nonlin(:), nonlin2(:), nonlin3(:), nonlin4(:),nonlin5(:),nonlin6(:), nonlin7(:),  contnonlin2(:), randnos3(:), randnos4(:)   
double precision, allocatable :: randnos2(:), totcon(:), toteis(:), totexp(:)
double precision, allocatable :: totgappay(:),totpay(:),totwage(:), totsav(:), varcon(:), varpay(:) ,  varpart(:) ,totexpun(:) 
double precision, allocatable ::totfixed(:), totpaypart(:), avnoofexit(:), avnumbyexit(:)
double precision, allocatable :: avnumperout(:), avnoexitreenty(:)
double precision, allocatable :: meduration(:),icons(:,:),ileis(:,:), iwage(:,:), iwbefaft(:),iiwbefaft(:)


integer, private:: a, bit,dumi, expval, expto, expcond, i, ifail, &
				j, jl, jm, ju, node, nodebit, nodeas, nodeas2,  offeralpha, p, s, seed, stat, t, &
				nodebit2, trwnode2, ptrnode, tt, ttt, w,  xmin, z, hit

integer, allocatable:: 	partip(:), yearswork(:,:)



double precision::derv1, derv2, u1, u2, u3, uc, ul, euler, mrs !was real

integer::agechild1, agechild2, aux2,aux3,contbefaft,contyrskids, contyrskids1,contyrskids2, &
            contyrskids1elas,contyrskids2elas, cont3to18, nomot,  jj, yrsexp, contyrskidstmp, &
            contyrskidstmp2, contyrskidstmp3,ind,ind2,ind3,ind5,ind10,ind18

integer, allocatable :: noofexit(:), numbyexit(:), numperout(:),noexitreenty(:)
integer, allocatable :: ipart(:),  inumbyexit(:,:), iinumbyexit(:,:)

   

contains 

subroutine allocate_simulate( iret  )
		implicit none
		integer, intent(out)	:: iret
		integer								:: ier(2) 

		allocate (avpart(totlen), nonlin(totlen), nonlin2(totlen), nonlin3(totlen), nonlin4(totlen), nonlin5(totlen), nonlin6(totlen),nonlin7(totlen), contnonlin2(totlen), &
			randnos2(nt*nosims), randnos3(nt*nosims), randnos4(nt*nosims),&
			totcon(totlen), toteis(totlen), totexp(totlen), totexpun(totlen), totfixed(totlen), totgappay(totlen),&
			totpaypart(totlen), totpay(totlen), totwage(totlen), totsav(totlen), varcon(totlen), varpay(totlen), varpart(totlen), & 
			avnoofexit(totlen), avnumbyexit(totlen), avnumperout(totlen), avnoexitreenty(totlen),&
		    stat=ier(1) )

		allocate ( ipart(totlen), icons(nosims,totlen), ileis(nosims,totlen), iwage(nosims,totlen), partip(totlen), noofexit(totlen), numbyexit(totlen), &
		noexitreenty(totlen), inumbyexit(nosims,totlen), iinumbyexit(nosims,totlen), &
		iwbefaft(nosims),iiwbefaft(nosims),numperout(totlen), 	meduration(totlen),  &
		yearswork(nosims,totlen), stat=ier(2) )

		do i=1,2
			if ( ier(i) .ne. 0) then 
				iret = -i
				return
			endif
		enddo

		iret = 0   

end subroutine allocate_simulate
!_______________________________________________________________________
subroutine empsim
     
	
	lowun = 0.d0
	highun = 1.d0
	
	
	ind2=2*(1-quarter)+12*quarter !age of child below 3 years   (t-agekid)
	ind3=3*(1-quarter)+13*quarter !age of child below 4 years   
    ind5=5*(1-quarter)+24*quarter !age of child below 6 years
    ind18=18*(1-quarter)+69*quarter !age of child below 18 years
    
    
	ind10=10*(1-quarter)+40*quarter !10 years
   

    call init_random_seed(123457)
	
		do i = begnosims,weignosims
			
			if(Icycle.gt.2)then
				if(i.ge.begnosims.AND.i.le.(begnosims+int(0.2*propkid(ki)*nosims+0.5d0)))then
					hit=1
				else	
					hit=0
				endif
			else
				hit=0
			endif
			


		  bit = (i-1)*nt

		  ipart = 0
		  noofexit = 0
		  numperout= 0
		  numbyexit= 0
		  noexitreenty = 0
		  yrsexp = 0
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!WORKING LIFE
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			do t = 1,nt

				age = t
				ageto = t+1

				node = bit + t
				
				year=(t-1)/4 + 1
				
				
				
				
				
				!1--------------------------find current state

				if (age.eq.1) then  
					! find INITIAL permanent wage
					if(nw.gt.1.and.pnw.gt.1)then
					    do j=1,nw
					      do p=1,pnw
						  
					
						    if (randnos1(node).le.contot(j,p,1,1,age)) then
							    wnode    = j
							    pnode    = p
								
							    goto 10077
						    endif
                          enddo
					    enddo
					else
					    wnode=1
					    pnode=1
					endif
					
					
10077				continue

					expval    = 1 !noexp
				    experien  = expvalue(expval,t)
					wage    = xw(wnode,t) *  experien  
					part    = pxw(pnode,t)  
					asset   = 0.001d0
				
					
				else

					asset = saving * detrr
                    
                    
					! find new permanent wage and permanent earnings
					if(pnw.gt.1.and.nw.gt.1)then
					        if(quarter.eq.0)then
					            do j=1,nw
					            do p=1,pnw  
						            if (randnos1(node).le.contot(j,p,wnode,pnode,age)) then
    							        
									    wnode    = j
									    pnode	 = p
									    
    							        
							            goto 77
						            endif
			                    enddo
					            enddo
					        else  !quarter
					        				           
					            if(t.eq.(year-1)*4+Iupdate(i,year))then !update
					            
					                do j=1,nw
					                do p=1,pnw  
						                if (randnos1(node).le.contot(j,p,wnode,pnode,age)) then
        							        
									        wnode    = j
									        pnode	 = p
									        
        							        
							                goto 77
						                endif
			                        enddo
					                enddo
					                !OTHERWISE same wnode and pnode
					            endif !update
					            
					          
					            if(Icycle.eq.1.AND.year.eq.age_cycle)then  !bust 
		                            wnode=min(j+1,nw)
						            pnode=min(p+1,pnw)
						        elseif(Icycle.eq.2.AND.year.eq.age_cycle)then !boom 
						            wnode=max(j-1,1)
						            pnode=max(p-1,1)
								elseif(Icycle.eq.3.AND.year.eq.age_cycle.AND.hit.eq.1)then !bust-20% 
						            wnode=max(j+2,1)
						            pnode=max(p+2,1)
								elseif(Icycle.eq.4.AND.year.eq.age_cycle.AND.hit.eq.1)then !boom-20% 
						            wnode=max(j-2,1)
						            pnode=max(p-2,1)
								endif
					        
	
					        endif  !quarter
					   else
					        wnode=1
					        pnode=1
					   
					   endif !nw,pnw>1
					        
			
77      				continue


					
					part     = pxw(pnode,t)  

					!wage depends on experience: so weighted average of high and low experience
					if(noexp.ge.2)then
						if (experien.le.expvalue(1,age)) then 
							
							probhigh = 0.d0	  !this is a weighting in a linear interpolation
							expval   = 1
						
						elseif (experien.ge.expvalue(noexp,age).or.expto.eq.noexp) then 
							
							probhigh = 1.d0
							expval   = noexp
						
						elseif (expto.lt.noexp) then
							
							probhigh = 1.d0 - (expvalue(expto+1,age) - experien) / & 
								(expvalue(expto+1,age) - expvalue(expto,age) ) 

							if (randexp(node).le.probhigh) then
								expval = expto + 1
							else
								expval = expto
							endif						

						endif
						wage     = xw(wnode,t) * expvalue(expval,t) 
					else
						wage     = xw(wnode,t) 
						expval=1
					endif

					 
																				   				

				endif

				xvalue=expval

			

				visitexpvalue(age,xvalue)=visitexpvalue(age,xvalue) + 1


				partcash = asset + part			

				nodeas2  = (wnode-1)*pnw*noexp + (pnode-1)*noexp + expval
				nodebit2 = (wnode-1)*pnw*na*noexp + (pnode-1)*na*noexp + (expval-1)*na
				!this is for not working state where transitory shock does not matter
				!so assume worst transitory shock to give broadest asset range

                xvalue = expval

				!2---------------------------find optimal decisions
                
				if (asscut(nodeas2,age).lt.partcash) then !not working

					stat     = 0
					call consumpt( stat, cons, leis, nodeas2, nodebit2)


					experien = expvalue(expval,t) * (1.d0 - deltaperF(expvalue(expval,t)))
					
					if(t.lt.nt.and.noexp.ge.2)then
						expto = max(mapping(t,expval,0,0.d0),1)
					else
						expto = 1
					endif
					saving = partcash - cons
					leis = hours
					
					if(partcash>maxpartcash(t))maxpartcash(t)=partcash

					 ipart(t)=0
					 iwage(i,t)=wage
					 icons(i,t)=cons
					 ileis(i,t)=hours
					
				else !working

					stat = 1
					
					call consumpt( stat, cons, leis, nodeas2, nodebit2)		
					experien = humancap(t,expvalue(expval,t), hours-leis )
					yrsexp = yrsexp + 1
					
					

					if(t.lt.nt.and.noexp.ge.2)then
						expto = max(mapping(t,expval,1,hours-leis),1)
					else
						expto = 1
					endif

					
					saving	= partcash + wage*(hours - leis) - fixed(t) - cons
					
					
					ipart(t)=1
					iwage(i,t)=wage
					icons(i,t)=cons
					ileis(i,t)=leis
					
				endif
				
				hourswork=hours - leis
				yearswork(i,t) = yrsexp

             

			
				!3----------------------------------variables to build several statistics
				
				logcon       = log(cons)
				logpart      = log(part)
				
				if (stat.gt.0) logpay = log(wage*(hours-leis))
				
				if (stat.gt.0) toteis(t) = toteis(t) + hours - leis
			  
				totcon(t)	 = totcon(t) + logcon
				varcon(t)	 = varcon(t) + logcon*logcon
				totfixed(t)	 = totfixed(t) + fixed(t)
				totsav(t)    = totsav(t) + saving			
				totpaypart(t)= totpaypart(t) + part !logpart
				varpart(t)   = varpart(t) + logpart*logpart

				if (t.ge.startobs.AND.t.le.endobs) totgappart = totgappart + part/hoursfix

				!--------------------------------------------------------------------------------------------------
				uc=margutc(cons,leis,t)
                ul=margutl(cons,leis,t)
                
				if (t.ge.2) then 
				    euler=uc/margutc(ocons,oleis,t-1)
					nonlin(t) = nonlin(t) + euler
				endif
				
				if(stat.gt.0)then
					
						contnonlin2(t) = contnonlin2(t) + 1.d0
						mrs=uc*wage/ul
						nonlin2(t) = nonlin2(t) + mrs
					
				endif
				
				u1=ucc(cons,leis,t)
				u2=ull(cons,leis,t)
				u3=u1*u2-(ucl(cons,leis,t))**2.d0
				nonlin3(t) = max(u1,nonlin3(t))
				nonlin4(t) = max(u2,nonlin4(t))
				nonlin5(t) = min(u3,nonlin5(t))
				nonlin6(t)=u1/uc
				nonlin7(t)=u2/ul
				!--------------------------------------------------------------------------------------------------
if(id==0.and.Isample.eq.1)write(44,'(6i6,1i3,1x,6f14.2,4f14.5)')i,agekid,hit,t,expval,yrsexp,stat,saving,part,partcash,wage,cons,leis,alfa,alfad(t),euler,mrs

if(id==0.and.Isample.eq.0)write(44,'(4i6,1i3,1x,3f14.2,1f14.5)')i,agekid,hit,t,stat,part,wage,leis,alfa
	

	
					
				if(t>=startobs.AND.t<=endobs)then
				    if (t-agekid.lt.0.OR.t-agekid2.gt.ind18)then
						    nomot = nomot + 1
				    endif
				
				
					if ((t-agekid.le.ind2.and.t-agekid.ge.0).or.(t-agekid2.le.ind2.and.t-agekid2.ge.0))then
						contyrskids = contyrskids + 1
					endif
				
				
				
					if (t-agekid.ge.ind3.and.t-agekid2.le.ind18)then
						cont3to18 = cont3to18 + 1
					endif

				endif
				
	
		

				!--------------------------------------------------------------------------------------------------
				
				totwage(t) = totwage(t) + log(wage)
				if (stat.gt.0) then 		
					if(t>=startobs.AND.t<=endobs)then
						if ((t-agekid.le.ind2.and.t-agekid.ge.0).or.(t-agekid2.le.ind2.and.t-agekid2.ge.0))then
							partkid = partkid + 1.d0
						endif

					
				
						if (t-agekid.lt.0.or.t-agekid2.gt.ind18) then
							partnomot = partnomot + 1.d0
						endif
						
						if (t-agekid.ge.ind3.and.t-agekid2.le.ind18) then
							p3to18 = p3to18 + 1.d0
						endif	
						
		
						
					
					endif !startobs endobs
					
			
					
					partip(t) = partip(t) + 1
					
				
					totpay(t) = totpay(t) + logpay
				
					if (t.ge.startobs.AND.t.le.endobs) totgappay(t) = totgappay(t) + wage 

					varpay(t) = varpay(t) + logpay*logpay
					

					totexp(t) = totexp(t) + expvalue(expval,t)
			 
				else

				     totexpun(t) = totexpun(t) + expvalue(expval,t)
				
				endif !stat=1
				
				
				oldcon = logcon
				ocons  = cons
				oleis  = leis

				
					

			enddo  !end of working time
			
			
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!RETIREMENT LIFE
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
					
			assterm = saving * detrr
			socsec = ssi*part
            leis = hours

			wnode=1
			expval=1

			!nodeas2  = (wnode-1)*pnw*noexp + (pnode-1)*noexp + expval
			!we do not use nodea2s becasue xanon() is not contingent on states from t=nt+1 to nt+ret
			!nodebit2 = (wnode-1)*pnw*na*noexp + (pnode-1)*na*noexp + (expval-1)*na
            nodebit2 = (pnode - 1)*na*noexp  
			
			do t=1,ret	
			    stat=0

				age = t + nt		

                partcash = assterm + socsec	
                if(t.lt.ret)then		
			        call consumpt( 0, cons, leis, 1, nodebit2)
			    else
			        cons=partcash
			        leis=hours
			    endif
				
			
			    saving = assterm + socsec - cons
			    assterm = detrr * saving
			    
			    if(partcash>maxpartcash(nt+t))maxpartcash(nt+t)=partcash			
                
				logcon = log(cons)			  
			  	differ		= logcon !- oldcon
				totcon(nt+t)	= totcon(nt+t) + differ
				uc=margutc(cons,leis,nt+t)
				euler= uc/margutc(ocons,oleis,nt+t-1)
				nonlin(nt+t) = nonlin(nt+t) + euler
				totsav(nt+t) = totsav(nt+t) + saving

				ocons = cons
				oleis = hours
				
			    u1=ucc(cons,leis,nt+t)
			    u2=ull(cons,leis,nt+t)
			    u3=u1*u2-(ucl(cons,leis,nt+t))**2.d0
				
			
			    nonlin3(nt+t) = max(u1,nonlin3(nt+t))
			    nonlin4(nt+t) = max(u2,nonlin4(nt+t))
			    nonlin5(nt+t) = min(u3,nonlin5(nt+t))
				nonlin6(nt+t)=u1/uc
				
if(id==0.and.Isample.eq.1)write(44,'(6i6,1i3,1x,6f14.2,4f14.5)')i,agekid,hit,t+nt,0,0,stat,assterm,part,partcash,wage,cons,leis,alfa,alfad(t+nt),euler,1.d0
	
			enddo

			
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!wage before / wage after: only exits until age 32
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			if ( sum(ipart).gt.0.and.sum(ipart).lt.nt) then
			    do tt=startobs+1,ind10 !2,nt-1
			        if(ipart(tt).eq.0.and.ipart(tt-1).ne.0.AND.sum(ipart(tt:endobs))>1)then
			            do ttt=tt+1,endobs !nt
			                if(ipart(ttt).eq.1)then
			                    iwbefaft(i)= 1.d0 - (iwage(i,ttt)/iwage(i,tt-1))**(1.0/dble((ttt-tt)))
 			                    contbefaft=contbefaft+1
			                    exit
			                endif
			            enddo
			            exit
			        endif
			    end do
			endif
			
	
		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		!exits: only exits until age 32 (10), come back before 40 (18)
		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		if ( sum(ipart).gt.0.and.sum(ipart).lt.nt) then 

			do tt=startobs,ind10 !1,nt-1
			!MOVE TO LINE 101, BEFORE LOOP ON i
			!	numperout(tt+1) = 0  !total duration by age
			!	numbyexit(tt+1) = 0	 !total duration by age of exit
			!MOVE TO LINE 107, BEFORE LOOP ON t
			!	inumbyexit(i,tt+1)=0
				if( ipart(tt+1).eq.0)then
							  numperout(tt+1)=1
							  do ttt=tt+2,nt
								if(ipart(ttt).eq.0)then
									numperout(tt+1)=numperout(tt+1) + 1
								else
									exit
								endif
							  enddo

							  do ttt=tt,1,-1
								if(ipart(ttt).eq.0)then
									numperout(tt+1)=numperout(tt+1) + 1
								else
									exit
								endif
							  enddo
				endif

				if( ipart(tt).eq.1.and.ipart(tt+1).eq.0.AND.sum(ipart(tt:ind18))>1)then
							
							noofexit(tt+1) = 1
							
							noexitreenty(tt+1) = 1 !new
							numbyexit(tt+1)	 =1
							inumbyexit(i,tt+1) =1

							do ttt=tt+2,ind18 !nt
								if(ipart(ttt).eq.0)then
									numbyexit(tt+1)=numbyexit(tt+1) + 1
									inumbyexit(i,tt+1)=inumbyexit(i,tt+1) + 1
								else
									exit
								endif
							enddo
				!Note we are only counting forwards because this is by age of exit.
				endif

			enddo  !end loop over time to calculate duration bits

			do t=2,nt !loop  to give age dependent duration
				avnumperout(t)		=avnumperout(t) + numperout(t) 
				avnumbyexit(t)		=avnumbyexit(t) + numbyexit(t)
				avnoofexit(t)		=avnoofexit(t)	+ dble(noofexit(t))
				avnoexitreenty(t)	=avnoexitreenty(t) + dble(noexitreenty(t) )												  
			enddo
		endif

		enddo !end weignosims , end individual i 


end subroutine empsim

end module simulate

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
