module statistics

use params
use simulate
use banner
use inputs
use bisection 

implicit none

double precision, allocatable, private:: xreg(:,:),  workwages(:), yreg(:), BB(:)
double precision, private :: coefofvar, growthY, growthO, fffpar,  femav, simmeanw ,simvarw,  stats(5),aux1, h_earn
integer, private :: a, counter, countpartY, countpartO, cont, i, j, ier, IFAIL, t ,noobs, noreg, x


contains 

  
subroutine simulstats 
    
       
    mult = dble(nosims)
	if(id==0)then
		wrunit=20
		call outputpp2
	endif
    

	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !wage growth  
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    countpartY = 0 !younger than 40
    growthY = 0.d0
    do i=1,nosims
        do t=max(2,startobs),13*(1-quarter)+quarter*72
            if (ileis(i,t).lt.hours.and.ileis(i,t-1).lt.hours)then
			 
                countpartY = countpartY + 1                
                growthY = growthY + log(iwage(i,t)/iwage(i,t-1))
            endif
        enddo
    enddo
	if(quarter.eq.0)then
	    growthY = growthY/dble(countpartY)
	else
	    growthY = (1.d0 + growthY/dble(countpartY))**3.d0 -1.d0
	endif

    countpartO = 0 !40 or older
	growthO = 0.d0
    do i=1,nosims
         do t=14*(1-quarter)+quarter*73,endobs 
               if (ileis(i,t).lt.hours.and.ileis(i,t-1).lt.hours)then
			   
                  countpartO = countpartO + 1
                  growthO = growthO + log(iwage(i,t)/iwage(i,t-1))                    
               endif
          enddo
    enddo

    if(quarter.eq.0)then
	    growthO = growthO/dble(countpartO)
	else
	    growthO = (1.d0 + growthO/dble(countpartO))**3.d0 -1.d0
	endif
    
           
       
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !coeff of variation
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 

	noobs=0
	do i=1,nosims
        do t=1,nt            
            if (ileis(i,t).lt.hours) then 
                noobs= noobs + 1
            endif
        enddo
    enddo

    allocate (workwages(noobs))
    counter = 0
    do i=1,nosims
        do t=1,nt            
            if (ileis(i,t).lt.hours) then 
                counter= counter + 1
                workwages( counter ) = iwage(i,t)
            endif
        enddo
    enddo
    
    !now calculate the coeff of variation
    simmeanw = sum(workwages)/noobs
    simvarw  = sum(workwages**2)/noobs - simmeanw**2
    coefofvar = sqrt(simvarw)/simmeanw
    deallocate (workwages)
   
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !gender gap
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    femav = 0.d0 
    do t=startobs,endobs
        femav = femav + totgappay(t)/partip(t)
    enddo
    gendergap = femav / (totgappart/dble(nosims)) 
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !wage before after
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    
	  if (contbefaft.gt.0.d0) then 
		aux1=dble(contbefaft) 
	
        iiwbefaft = iwbefaft
        call sortdp(nosims,iiwbefaft)  !sorting double precision
        if (ifail.ne.0) write (10,*) 'failing in sorting depreciation '

		if(aux1/2.d0.gt.int(aux1/2.d0)+0.2d0)then !number of exits is an odd number

			aux2=(nosims-int(aux1))+int(aux1/2.d0)+1
			mediandelta=iiwbefaft(aux2)

		else	!number of exits is an even number

			aux2=(nosims-int(aux1))+int(aux1/2.d0)
			aux3=(nosims-int(aux1))+int(aux1/2.d0)+1
			mediandelta=0.5d0*iiwbefaft(aux2)+0.5d0*iiwbefaft(aux3)

		endif
	  else	!set to 0 if no one exits
		mediandelta= 0.d0 
	  endif
	
	  if(quarter.eq.1)then
	    mediandelta=1.d0 - (1-mediandelta)**4.d0
	  endif

	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	!duration of exit
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	
	do t=2, endobs !nt
	  if (avnoexitreenty(t).gt.0.d0) then 
			aux1=avnoexitreenty(t) !new
		
			iinumbyexit(:,t) = iinumbyexit(:,t)  !sorting integers
			call sort(nosims, iinumbyexit(:,t) )
			if (ifail.ne.0) write (10,*) 'failing in sorting durations '

			if(aux1/2.d0.gt.int(aux1/2.d0)+0.2d0)then !number of exits is an odd number

				noobs=(nosims-int(aux1))+int(aux1/2.d0)+1
				meduration(t)=iinumbyexit(noobs,t)

			else	!number of exits is an even number

				noobs=(nosims-int(aux1))+int(aux1/2.d0)
				noobs=(nosims-int(aux1))+int(aux1/2.d0)+1
				meduration(t)=0.5d0*iinumbyexit(aux2,t)+0.5d0*iinumbyexit(aux3,t)

			endif
	  else	!set to 0 if no one exits
		meduration(t) = 0.d0 
	  endif

	end do
	
	
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	!age profiles
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !average earnings, experience, participation
    do t = 1,nt+ret     
 
		        totcon(t) = totcon(t)/mult

				totpaypart(t)=totpaypart(t)/mult

				varpart(t) = varpart(t)/mult - totpaypart(t)*totpaypart(t)
            

		        if (partip(t).gt.0) then 

			        totpay(t) = totpay(t)/dble(partip(t))
					
        		
			        varpay(t) = varpay(t)/dble(partip(t)) - totpay(t)*totpay(t)
			        toteis(t) = toteis(t)/dble(partip(t))
        				
			        totexp(t) = totexp(t)/dble(partip(t))
		        else
!			   
			        totpay(t) = 0.d0
			        varpay(t) = 0.d0
			        avpart(t) = 0.d0			
		        endif
        		
		        if (partip(t).lt.nosims) then
			        totexpun(t) = totexpun(t)/(mult - dble(partip(t)))
			        avnumperout(t)=avnumperout(t)/(mult - dble(partip(t)))

			        if (t.gt.1.and.avnoexitreenty(t).gt.0) then 
				        avnumbyexit(t)=avnumbyexit(t)/(avnoexitreenty(t))
			        endif
		        endif
        		
		        if (t.gt.1) then 
			        if (partip(t-1).gt.0) then 
				        avnoexitreenty(t)=avnoexitreenty(t)/dble(partip(t-1))
			        endif
		        endif
        		
		        if (t.gt.1) then 
			        if (partip(t-1).gt.0) then 
				        avnoofexit(t)=avnoofexit(t)/dble(partip(t-1))
			        endif
		        endif
        			

		        avpart(t) = partip(t)/mult			 	
		        
        		totwage(t) = totwage(t)/mult
          
		        totsav(t) = totsav(t)/mult
		        nonlin(t) = nonlin(t)/mult* detrr * disc
				if(t.le.nt)nonlin2(t) = nonlin2(t)/contnonlin2(t)
		        varcon(t) = varcon(t)/mult - totcon(t)*totcon(t) 
        		totfixed(t) = totfixed(t)/mult
        		  
      enddo  






!calibrated statistics

partaft=max(partaft,0.0000001d0)

calibstats(1)= partnomot/dble(nomot)
calibstats(2)= sum(partip(startobs:endobs))/dble(nosims*tobs)
calibstats(3)= partkid/dble(contyrskids)
calibstats(4)= mediandelta
calibstats(5)= gendergap
calibstats(6)= growthY 
calibstats(7)= growthO 
calibstats(8) = p3to18/dble(cont3to18)
calibstats(9)= partkid1/dble(contyrskids1)
calibstats(10)= partkid2/dble(contyrskids2)
calibstats(11)= sum(toteis(startobs:endobs))/dble(tobs)




namest(1)='pnomot'
namest(2)='part'
namest(3)='partkid'
namest(4)='depr'
namest(5)='ggap'
namest(6)='grow1'
namest(7)='grow2'
namest(8)='P3to18'
namest(9)='pyMOT'
namest(10)='poMOT'
namest(11)='hours'



namepar(1)='xi'
namepar(2)='theta'
namepar(3)='phi'
namepar(4)='alpha'
namepar(5)='ccost'
namepar(6)='delta1'
namepar(7)='ggpa'
namepar(8)='oleta0'
namepar(9)='oleta1'
namepar(10)='cwork'
namepar(11)='mu'


!calibration errors
do j=1,npar
	fpar(j)=(statdat(j)-calibstats(j))*caliweig(j)
end do
fffpar=0.d0 
do j=1,npar
    fffpar=fffpar+ ( (statdat(j)-calibstats(j))/statdat(j) )**2.d0
enddo
if(fffpar>0.d0)fffpar=sqrt(fffpar)


if(fffpar<besterror)then
    bestiter=imodel
    besterror=fffpar
endif



if (id.eq.0) then
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!life-cycle profiles

	  write(20,*)'Life Cycle Participation'
      write (20,8886) ( avpart(i),i=1,nt)
      write (20,*) 
      write(20,*)'Life Cycle Consumption' 
      write (20,8886) ( totcon(i),i=1,totlen)  
      write (20,*) 
      write(20,*)'Life Cycle Hours of work, if Working'
      write (20,8886) ( toteis(i),i=1,nt)  
      write (20,*) 
      write(20,*)'Life Cycle Fixed Costs ki=3'
      write (20,8886) ( fixed(i),i=1,nt)  
      write (20,*) 		   
      write(20,*)'Life Cycle Earnings (wage*hourswork)'
      write (20,8886) ( totpay(i),i=1,nt) 
      write (20,*) 
	  write(20,*)'Life Cycle Offered Wages'
      write (20,8886) ( totwage(i),i=1,nt) 
      write (20,*) 
      write(20,*)'Life Cycle Partner Earnings'
      write (20,8886) ( totpaypart(i),i=1,nt) 
      write (20,*) 
      write(20,*)'Average Partner Earnings'
      h_earn=sum(totpaypart(1:nt)/nt)
      write (20,8886) h_earn 
      write (20,*)
      write(20,*)'Life Cycle Savings' 
      write (20,8886) ( totsav(i), i=1,totlen)
      write (20,*) 
      write(20,*)'Equival Scale ki=3' 
      write (20,8886) ( equival(i), i=1,nt)
      write (20,*) 
      write(20,*)'Average value of parameter alpha (depends on demographics)' 
      write (20,8886) ( alfad(i), i=1,nt)
      write (20,*) 
       

      write(20,*)'Var Con' 
      write (20,8889) ( varcon(i), i=2,nt)
      write (20,*) 
      write(20,*)'Var Pay' 
      write (20,8889) ( varpay(i), i=2,nt)	
      write (20,*) 
	  write(20,*)'Var Pay Partner' 
      write (20,8889) ( varpart(i), i=2,nt)	
      write (20,*) 
      write (20,*) 'The following numbers should all be equal to 1:		'
      write (20,*) 'This is the average of the simulated FOC u_c(t)*beta*R/u_c(t-1) '
      write (20,8889) ( nonlin(i), i=2,totlen)
      write(20,*)
	  write (20,*) 'This is the average of the simulated FOC w*u_c(t)/u_l(t), for stat=1 '
      write (20,8889) ( nonlin2(i), i=1,nt)
      write (20,*)       
      write (20,*) 'Concavity, MAX ucc  '
      write (20,8889) ( nonlin3(i), i=2,nt+ret)
      write (20,*)
      write (20,*) 'Concavity, MAX ull  '
      write (20,8889) ( nonlin4(i), i=2,nt+ret)
      write (20,*)
      write (20,*) 'Concavity, MIN ucc*ull-ucl*ucl  '
      write (20,8889) ( nonlin5(i), i=2,nt)
      write (20,*) 
	  
	  write (20,*) 'ucc/uc '
      write (20,8889) ( nonlin6(i), i=2,nt)
      write (20,*) 
	  
	  write (20,*) 'ull/ul  '
      write (20,8889) ( nonlin7(i), i=2,nt)
      write (20,*) 
	

	  
   
!main statistics
write(20,*)
write(20,*)'Main Statistics: ',startobs,endobs
write(20,'(/,1x,a8,5a11)')'    ','params'&
         & ,'    ','Targets-Vals', 'Model-Vals'

	write(20,213)namepar(10),modpars(10),namest(2),statdat(2),calibstats(2)
	write(20,213)namepar(7),modpars(7),namest(3),statdat(3),calibstats(3)
	write(20,213)namepar(5),modpars(5),namest(5),statdat(5),calibstats(5)
	write(20,213)namepar(4),modpars(4),namest(11),statdat(11),calibstats(11)
	
	write(20,*)''
	write(20,213)namepar(8),modpars(8),namest(6),statdat(6),calibstats(6)
	write(20,213)namepar(9),modpars(9),namest(7),statdat(7),calibstats(7)
	
	write(20,*)''
	write(20,213)namepar(6),modpars(6),namest(4),statdat(4),calibstats(4)
	
	write(20,*)''
	write(20,215)namest(8),statdat(8),calibstats(8)
	write(20,215)namest(9),statdat(9),calibstats(9)
	write(20,215)namest(10),statdat(10),calibstats(10)
	write(20,215)namest(1),statdat(1),calibstats(1)
	
	

!main statistics
write(1111,*)
write(1111,*)'Main Statistics 25-60 '
write(1111,'(/,1x,a8,5a11)')'    ','params'&
         & ,'    ','Targets-Vals', 'Model-Vals'

	write(1111,213)namepar(10),modpars(10),namest(2),statdat(2),calibstats(2)
	write(1111,213)namepar(7),modpars(7),namest(3),statdat(3),calibstats(3)
	write(1111,213)namepar(5),modpars(5),namest(5),statdat(5),calibstats(5)
	write(1111,213)namepar(4),modpars(4),namest(11),statdat(11),calibstats(11)
	write(1111,*)''
	write(1111,213)namepar(6),modpars(6),namest(4),statdat(4),calibstats(4)
	write(1111,213)namepar(8),modpars(8),namest(6),statdat(6),calibstats(6)
	write(1111,213)namepar(9),modpars(9),namest(7),statdat(7),calibstats(7)
	
	
	write(1111,*)namepar(11),modpars(11)
    write(1111,*)namepar(1),modpars(1)
    write(1111,*)namepar(2),modpars(2)
    write(1111,*)namepar(3),modpars(3)





!Possible checks on what is happening in the solution
write (21,*) 
write (21,*) 'not working bit visited '
do t=1,nt
	write (21,*) 
	do a=1,na
		if (visitnon(t,a).gt.0) write (21,*) t,a,visitnon(t,a),xanon(a,1,t)
	enddo
	!if(visitnon(t,na-1).gt.0)write(20,*)'Upper Bound is Binding in xanon',visitnon(t,a)
enddo
write (21,*) 
do t=nt+1,nt+ret
	write (21,*) 
	do a=1,na
		if (visitnon(t,a).gt.0) write (21,*) t,a,visitnon(t,a),xanon(a,1,t)
	enddo
	!if(visitnon(t,na-1).gt.0)write(20,*)'Upper Bound is Binding in xanon',visitnon(t,a)
enddo
write (21,*) 

write (21,*) 'working bit visited '
do t=1,nt
	write (21,*) 
	do a=1,na
		if (visitemp(t,a).gt.0) write (21,*) t,a,visitemp(t,a),xawork(a,1,t)
	enddo
	!if(visitemp(t,na-1).gt.0)write(20,*)'Upper Bound is Binding in xawork',visitemp(t,a)
enddo


write (9996,*)
do a=1,3
do t=1,nt+ret

		 write (9996,*) a,t,countcornerUmin(a,t)
enddo;enddo
write (9996,*) 
write (9997,*)
do a=1,3
do t=1,nt+ret

		 write (9997,*) a,t,countcornerUmax(a,t)
enddo;enddo
write (9997,*)
write (9998,*)
do a=1,3
do t=1,nt+ret

		 write (9998,*) a,t,countcornerEmin(a,t)
enddo;enddo
write (9998,*)
write (9999,*)
do a=1,3
do t=1,nt+ret

		 write (9999,*) a,t,countcornerEmax(a,t)
enddo;enddo
write (9999,*)   
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


endif !id=0



    

8888 format (5(f13.5,2X))   

9999 format (3(3x,e14.6),I4)
6999 format (4(3x,e14.6),2x,I4)

9998 format (5(2x,e14.6))

8890 format (E14.6)
8889 format (5(e16.5,2X) )   
8886 format (5(f16.5,2x))
212  format (1x,a9,i3,1x,a4,1x,e13.4,2x,a8,1x,i4,2x,a9,1x,e13.5)
213  format (1x,a7,e13.4,1x,a7,3e13.5)
214  format (1x,a14,3f14.6)
215  format (1x,a7,3e13.5)



contains

integer function ind1500(leis)
double precision leis

ind1500=0
if((hours-leis).ge.1500.d0)ind1500=1 

end function ind1500


end subroutine simulstats




!********************************************************************
! SUBROUTINE: easyols
!********************************************************************
SUBROUTINE easyols(ndata,nx,x,y,bhat,stats)
	implicit none

	!******* parameter *******
	integer, parameter:: prec=8

	!******* input/output variables *******
	integer,    intent(in)                       :: ndata, nx
	real(prec), intent(in),  dimension(ndata)    :: y
	real(prec), intent(in),  dimension(ndata, nx):: x
	real(prec), intent(out), dimension(5)        :: stats
	real(prec), intent(out), dimension(1+nx   )  :: bhat

	!******* local variables *******
	real(prec), dimension(ndata, nx+1 ):: x0
	real(prec), dimension(nx+1,  ndata):: xt
	real(prec), dimension(ndata, 1    ):: y0
	real(prec), dimension(nx+1,  1    ):: xy, bhat0
	real(prec), dimension(nx+1,  nx+1 ):: xx, xxinv
	integer                            :: d0

	!******* variables for linpacks package *******
	integer,    dimension(nx+1):: ipvt
	integer                    :: info, lda, n, job
	real(prec), dimension(nx+1):: work
	real(prec), dimension(2)   :: det

	!******* variables for calculating statistics *******
	real(prec), dimension(ndata):: e0, yhat, yt, yr
	real(prec)                  :: sse, ssr, sst, avy, rsq, adj_rsq

	!******* construct x0, y0 *******

	do d0=1, ndata
		x0(d0, 1)=1.0
		x0(d0, 2:nx+1)=x(d0, 1:nx)
		y0(d0, 1)     =y(d0)
	end do

	!******* construct transpose matrix of x *******
	xt=TRANSPOSE(x0)
	
	!write (*,*) 'xt ', xt

	!******* compute x'x *******
	xx=MATMUL(xt, x0)

    !write (*,*) 'xx ', xx

	!******* take inverse of xx *******
	xxinv= xx
	lda  =nx+1
	n    =nx+1
	job  =01
	call dgefa(xxinv, lda, n, ipvt, info)
	call dgedi(xxinv, lda, n, ipvt, det, work, job)

    !write (*,*) 'xxinv ', xxinv


	!******* construct xy *******
	xy=MATMUL(xt, y0)

	!******* construct beta hat *******
	bhat0=MATMUL(xxinv, xy)
	do d0=1, 1+nx
		bhat(d0)=bhat0(d0,1)
	end do

    !write (*,*) 'bhat ', bhat

	!******* calculate statistics *******
	avy=sum(y(1:ndata))/real(ndata, prec)
	do d0=1, ndata
		yhat(d0)=DOT_PRODUCT(bhat, x0(d0,:))
		e0(d0)=y(d0)-yhat(d0)
		yt(d0)=y(d0)-avy
		yr(d0)=yhat(d0)-avy
	end do
	!sst=DOT_PRODUCT(y, y)-real(ndata,prec)*avy**2.0
	sst=DOT_PRODUCT(yt,yt)
	ssr=DOT_PRODUCT(yr,yr)
	sse=DOT_PRODUCT(e0,e0)
	rsq=ssr/sst
	adj_rsq=1.0-real(ndata-1, prec)/real(ndata-nx-1, prec)*(1.0-rsq)

	!******* assign values to stats vector *******
	stats(1)=sse
	stats(2)=ssr
	stats(3)=sst
	stats(4)=rsq
	stats(5)=adj_rsq

END SUBROUTINE easyols

!********************************************************************
subroutine daxpy(n,da,dx,incx,dy,incy)
!********************************************************************
! constant times a vector plus a vector.
! uses unrolled loops for increments equal to one.
! jack dongarra, linpack, 3/11/78.
! modified 12/3/93, array(1) declarations changed to array(*)
double precision dx(*),dy(*),da
integer i,incx,incy,ix,iy,m,mp1,n
if (n.le.0) return
if (da .eq. 0.0d0) return
if (incx.eq.1.and.incy.eq.1) go to 20
! code for unequal increments or equal increments
! not equal to 1
ix = 1
iy = 1
if (incx.lt.0) ix = (-n+1)*incx + 1
if (incy.lt.0) iy = (-n+1)*incy + 1
do 10 i = 1,n
  dy(iy) = dy(iy) + da*dx(ix)
  ix = ix + incx
  iy = iy + incy
10 continue
return

! code for both increments equal to 1
! clean-up loop
20 m = mod(n,4)
if( m .eq. 0 ) go to 40
do 30 i = 1,m
  dy(i) = dy(i) + da*dx(i)
   30 continue
if( n .lt. 4 ) return
   40 mp1 = m + 1
do 50 i = mp1,n,4
  dy(i) = dy(i) + da*dx(i)
  dy(i + 1) = dy(i + 1) + da*dx(i + 1)
  dy(i + 2) = dy(i + 2) + da*dx(i + 2)
  dy(i + 3) = dy(i + 3) + da*dx(i + 3)
return
   50 continue
end subroutine daxpy

!********************************************************************
subroutine dscal(n,da,dx,incx)
!********************************************************************
! scales a vector by a constant.
! uses unrolled loops for increment equal to one.
! jack dongarra, linpack, 3/11/78.
! modified 3/93 to return if incx .le. 0.
! modified 12/3/93, array(1) declarations changed to array(*)
double precision da,dx(*)
integer i,incx,m,mp1,n,nincx
if( n.le.0 .or. incx.le.0 )return
if(incx.eq.1)go to 20
!  code for increment not equal to 1
nincx = n*incx
do 10 i = 1,nincx,incx
  dx(i) = da*dx(i)
   10 continue
return
!  code for increment equal to 1
!  clean-up loop
   20 m = mod(n,5)
if( m .eq. 0 ) go to 40
do 30 i = 1,m
  dx(i) = da*dx(i)
   30 continue
if( n .lt. 5 ) return
   40 mp1 = m + 1
do 50 i = mp1,n,5
  dx(i) = da*dx(i)
  dx(i + 1) = da*dx(i + 1)
  dx(i + 2) = da*dx(i + 2)
  dx(i + 3) = da*dx(i + 3)
  dx(i + 4) = da*dx(i + 4)
   50 continue
return
end subroutine dscal



!********************************************************************
subroutine dgedi(a,lda,n,ipvt,det,work,job)
!********************************************************************
integer lda,n,ipvt(n),job
double precision a(lda,n),det(2),work(n)
! dgedi computes the determinant and inverse of a matrix
! using the factors computed by dgeco or dgefa.
!
! on entry
!  a    double precision(lda, n)
!       the output from dgeco or dgefa.
!  lda  integer
!       the leading dimension of the array  a .
!  n    integer
!       the order of the matrix  a .
!  ipvt integer(n)
!       the pivot vector from dgeco or dgefa.
!  work double precision(n)
!       work vector.  contents destroyed.
!  job  integer
!       = 11   both determinant and inverse.
!       = 01   inverse only.
!       = 10   determinant only.
!
! on return
!  a    inverse of original matrix if requested.
!       otherwise unchanged.
!  det  double precision(2)
!       determinant of original matrix if requested.
!       otherwise not referenced.
!       determinant = det(1) * 10.0**det(2)
!       with  1.0 .le. dabs(det(1)) .lt. 10.0
!       or  det(1) .eq. 0.0 .
! error condition
!       a division by zero will occur if the input factor contains
!       a zero on the diagonal and the inverse is requested.
!       it will not occur if the subroutines are called correctly
!       and if dgeco has set rcond .gt. 0.0 or dgefa has set
!       info .eq. 0 .
!
! linpack. this version dated 08/14/78 .
! cleve moler, university of new mexico, argonne national lab.
!
! subroutines and functions
!       blas daxpy,dscal,dswap
!       fortran dabs,mod
!
! internal variables
double precision t
double precision ten
integer i,j,k,kb,kp1,l,nm1
! compute determinant
if (job/10 .eq. 0) go to 70
   det(1) = 1.0d0
   det(2) = 0.0d0
   ten = 10.0d0
   do 50 i = 1, n
if (ipvt(i) .ne. i) det(1) = -det(1)
det(1) = a(i,i)*det(1)
!  ...exit
if (det(1) .eq. 0.0d0) go to 60
   10 if (dabs(det(1)) .ge. 1.0d0) go to 20
   det(1) = ten*det(1)
   det(2) = det(2) - 1.0d0
go to 10
   20 continue
   30 if (dabs(det(1)) .lt. ten) go to 40
   det(1) = det(1)/ten
   det(2) = det(2) + 1.0d0
go to 30
   40 continue
   50    continue
   60    continue
   70 continue
! compute inverse(u)
if (mod(job,10) .eq. 0) go to 150
   do 100 k = 1, n
a(k,k) = 1.0d0/a(k,k)
t = -a(k,k)
call dscal(k-1,t,a(1,k),1)
kp1 = k + 1
if (n .lt. kp1) go to 90
do 80 j = kp1, n
   t = a(k,j)
   a(k,j) = 0.0d0
   call daxpy(k,t,a(1,k),1,a(1,j),1)
   80 continue
   90 continue
  100    continue
! form inverse(u)*inverse(l)
   nm1 = n - 1
   if (nm1 .lt. 1) go to 140
   do 130 kb = 1, nm1
k = n - kb
kp1 = k + 1
do 110 i = kp1, n
   work(i) = a(i,k)
   a(i,k) = 0.0d0
  110 continue
do 120 j = kp1, n
   t = work(j)
   call daxpy(n,t,a(1,j),1,a(1,k),1)
  120 continue
l = ipvt(k)
if (l .ne. k) call dswap(n,a(1,k),1,a(1,l),1)
  130    continue
  140    continue
  150 continue
return
end subroutine dgedi

!********************************************************************
subroutine dgeco(a,lda,n,ipvt,rcond,z)
!********************************************************************
integer lda,n,ipvt(n)
double precision a(lda,n),z(n)
double precision rcond
! dgeco factors a double precision matrix by gaussian elimination
! and estimates the condition of the matrix.
!
! if  rcond  is not needed, dgefa is slightly faster.
! to solve  a*x = b , follow dgeco by dgesl.
! to compute  inverse(a)*c , follow dgeco by dgesl.
! to compute  determinant(a) , follow dgeco by dgedi.
! to compute  inverse(a) , follow dgeco by dgedi.
!
! on entry
!    a     double precision(lda, n)
!          the matrix to be factored.
!    lda   integer
!          the leading dimension of the array  a .
!    n     integer
!          the order of the matrix  a .
!
! on return
!    a     an upper triangular matrix and the multipliers
!          which were used to obtain it.
!          the factorization can be written  a = l*u  where
!    l     is a product of permutation and unit lower
!          triangular matrices and  u  is upper triangular.
!    ipvt  integer(n)
!          an integer vector of pivot indices.
!    rcond double precision
!          an estimate of the reciprocal condition of  a .
!          for the system  a*x = b , relative perturbations
!          in  a  and  b  of size  epsilon  may cause
!          relative perturbations in  x  of size  epsilon/rcond .
!          if  rcond  is so small that the logical expression
!          1.0 + rcond .eq. 1.0
!          is true, then  a  may be singular to working
!          precision.  in particular,  rcond  is zero  if
!          exact singularity is detected or the estimate
!          underflows.
!    z     double precision(n)
!          a work vector whose contents are usually unimportant.
!          if  a  is close to a singular matrix, then  z  is
!          an approximate null vector in the sense that
!          norm(a*z) = rcond*norm(a)*norm(z) .
!
! linpack. this version dated 08/14/78 .
! cleve moler, university of new mexico, argonne national lab.
!
! subroutines and functions
!          linpack dgefa
!          blas daxpy,ddot,dscal,dasum
!          fortran dabs,dmax1,dsign
!
! internal variables
double precision ek,t,wk,wkm         !******* ddot  erased *******
double precision anorm,s,sm,ynorm    !******* dasum erased *******
integer info,j,k,kb,kp1,l
! compute 1-norm of a
anorm = 0.0d0
do 10 j = 1, n
   anorm = dmax1(anorm,dasum(n,a(1,j),1))
   10 continue
! factor
call dgefa(a,lda,n,ipvt,info)
! rcond = 1/(norm(a)*(estimate of norm(inverse(a)))) .
! estimate = norm(z)/norm(y) where  a*z = y  and  trans(a)*y = e .
! trans(a)  is the transpose of a .  the components of  e  are
! chosen to cause maximum local growth in the elements of w  where
! trans(u)*w = e .  the vectors are frequently rescaled to avoid
! overflow.
!
! solve trans(u)*w = e
ek = 1.0d0
do 20 j = 1, n
   z(j) = 0.0d0
   20 continue
do 100 k = 1, n
   if (z(k) .ne. 0.0d0) ek = dsign(ek,-z(k))
   if (dabs(ek-z(k)) .le. dabs(a(k,k))) go to 30
s = dabs(a(k,k))/dabs(ek-z(k))
call dscal(n,s,z,1)
ek = s*ek
   30    continue
   wk = ek - z(k)
   wkm = -ek - z(k)
   s = dabs(wk)
   sm = dabs(wkm)
   if (a(k,k) .eq. 0.0d0) go to 40
wk = wk/a(k,k)
wkm = wkm/a(k,k)
   go to 50
   40 continue
wk = 1.0d0
wkm = 1.0d0
   50 continue
   kp1 = k + 1
   if (kp1 .gt. n) go to 90
do 60 j = kp1, n
   sm = sm + dabs(z(j)+wkm*a(k,j))
   z(j) = z(j) + wk*a(k,j)
   s = s + dabs(z(j))
   60 continue
if (s .ge. sm) go to 80
   t = wkm - wk
   wk = wkm
   do 70 j = kp1, n
z(j) = z(j) + t*a(k,j)
   70 continue
   80 continue
   90 continue
   z(k) = wk
  100 continue
s = 1.0d0/dasum(n,z,1)
call dscal(n,s,z,1)

! solve trans(l)*y = w
do 120 kb = 1, n
   k = n + 1 - kb
   if (k .lt. n) z(k) = z(k) + ddot(n-k,a(k+1,k),1,z(k+1),1)
   if (dabs(z(k)) .le. 1.0d0) go to 110
s = 1.0d0/dabs(z(k))
call dscal(n,s,z,1)
  110 continue
   l = ipvt(k)
   t = z(l)
   z(l) = z(k)
   z(k) = t
  120 continue
s = 1.0d0/dasum(n,z,1)
call dscal(n,s,z,1)
ynorm = 1.0d0

! solve l*v = y
do 140 k = 1, n
   l = ipvt(k)
   t = z(l)
   z(l) = z(k)
   z(k) = t
   if (k .lt. n) call daxpy(n-k,t,a(k+1,k),1,z(k+1),1)
   if (dabs(z(k)) .le. 1.0d0) go to 130
s = 1.0d0/dabs(z(k))
call dscal(n,s,z,1)
ynorm = s*ynorm
  130 continue
  140 continue
s = 1.0d0/dasum(n,z,1)
call dscal(n,s,z,1)
ynorm = s*ynorm

! solve  u*z = v
do 160 kb = 1, n
   k = n + 1 - kb
   if (dabs(z(k)) .le. dabs(a(k,k))) go to 150
s = dabs(a(k,k))/dabs(z(k))
call dscal(n,s,z,1)
ynorm = s*ynorm
  150 continue
   if (a(k,k) .ne. 0.0d0) z(k) = z(k)/a(k,k)
   if (a(k,k) .eq. 0.0d0) z(k) = 1.0d0
   t = -z(k)
   call daxpy(k-1,t,a(1,k),1,z(1),1)
  160 continue
! make znorm = 1.0
s = 1.0d0/dasum(n,z,1)
call dscal(n,s,z,1)
ynorm = s*ynorm
if (anorm .ne. 0.0d0) rcond = ynorm/anorm
if (anorm .eq. 0.0d0) rcond = 0.0d0
return
end subroutine dgeco

!********************************************************************
subroutine dgefa(a,lda,n,ipvt,info)
!********************************************************************
integer lda,n,ipvt(n),info
double precision a(lda,n)
! dgefa factors a double precision matrix by gaussian elimination.
! dgefa is usually called by dgeco, but it can be called
! directly with a saving in time if  rcond  is not needed.
! (time for dgeco) = (1 + 9/n)*(time for dgefa).
!
! on entry
!    a    double precision(lda, n)
!         the matrix to be factored.
!    lda  integer
!         the leading dimension of the array  a .
!    n    integer
!         the order of the matrix  a .
! on return
!    a    an upper triangular matrix and the multipliers
!         which were used to obtain it.
!         the factorization can be written  a = l*u  where
!         l is a product of permutation and unit lower
!         triangular matrices and  u  is upper triangular.
!    ipvt integer(n)
!         an integer vector of pivot indices.
!    info integer
!         = 0  normal value.
!         = k  if  u(k,k) .eq. 0.0 .  this is not an error
!         condition for this subroutine, but it does
!         indicate that dgesl or dgedi will divide by zero
!         if called.  use  rcond  in dgeco for a reliable
!         indication of singularity.
!
! linpack. this version dated 08/14/78 .
! cleve moler, university of new mexico, argonne national lab.
!
! subroutines and functions
!         blas daxpy,dscal,idamax
!
! internal variables
double precision t
integer j,k,kp1,l,nm1   !******* idamax erased *******
! gaussian elimination with partial pivoting
info = 0
nm1 = n - 1
if (nm1 .lt. 1) go to 70
do 60 k = 1, nm1
   kp1 = k + 1

! find l = pivot index
   l = idamax(n-k+1,a(k,k),1) + k - 1
   ipvt(k) = l

! zero pivot implies this column already triangularized
   if (a(l,k) .eq. 0.0d0) go to 40

! interchange if necessary
if (l .eq. k) go to 10
   t = a(l,k)
   a(l,k) = a(k,k)
   a(k,k) = t
   10 continue

! compute multipliers
t = -1.0d0/a(k,k)
call dscal(n-k,t,a(k+1,k),1)

! row elimination with column indexing
do 30 j = kp1, n
   t = a(l,j)
   if (l .eq. k) go to 20
a(l,j) = a(k,j)
a(k,j) = t
   20 continue
   call daxpy(n-k,t,a(k+1,k),1,a(k+1,j),1)
   30 continue
   go to 50
   40 continue
   info = k
   50 continue
   60 continue
   70 continue
ipvt(n) = n
if (a(n,n) .eq. 0.0d0) info = n
return
end subroutine dgefa

!********************************************************************
double precision function dasum(n,dx,incx)
!********************************************************************
! takes the sum of the absolute values.
! jack dongarra, linpack, 3/11/78.
! modified 3/93 to return if incx .le. 0.
! modified 12/3/93, array(1) declarations changed to array(*)
double precision dx(*),dtemp
integer i,incx,m,mp1,n,nincx
dasum = 0.0d0
dtemp = 0.0d0
if( n.le.0 .or. incx.le.0 )return
if(incx.eq.1)go to 20
! code for increment not equal to 1
nincx = n*incx
do 10 i = 1,nincx,incx
  dtemp = dtemp + dabs(dx(i))
   10 continue
dasum = dtemp
return
! code for increment equal to 1
! clean-up loop
   20 m = mod(n,6)
if( m .eq. 0 ) go to 40
do 30 i = 1,m
  dtemp = dtemp + dabs(dx(i))
   30 continue
if( n .lt. 6 ) go to 60
   40 mp1 = m + 1
do 50 i = mp1,n,6
  dtemp = dtemp + dabs(dx(i)) + dabs(dx(i + 1)) + dabs(dx(i + 2)) &
     + dabs(dx(i + 3)) + dabs(dx(i + 4)) + dabs(dx(i + 5))
   50 continue
   60 dasum = dtemp
return
end function dasum

!********************************************************************
double precision function ddot(n,dx,incx,dy,incy)
!********************************************************************
! forms the dot product of two vectors.
! uses unrolled loops for increments equal to one.
! jack dongarra, linpack, 3/11/78.
! modified 12/3/93, array(1) declarations changed to array(*)
double precision dx(*),dy(*),dtemp
integer i,incx,incy,ix,iy,m,mp1,n
ddot = 0.0d0
dtemp = 0.0d0
if(n.le.0)return
if(incx.eq.1.and.incy.eq.1)go to 20
! code for unequal increments or equal increments not equal to 1
ix = 1
iy = 1
if(incx.lt.0)ix = (-n+1)*incx + 1
if(incy.lt.0)iy = (-n+1)*incy + 1
do 10 i = 1,n
  dtemp = dtemp + dx(ix)*dy(iy)
  ix = ix + incx
  iy = iy + incy
   10 continue
ddot = dtemp
return
! code for both increments equal to 1
! clean-up loop
   20 m = mod(n,5)
if( m .eq. 0 ) go to 40
do 30 i = 1,m
  dtemp = dtemp + dx(i)*dy(i)
   30 continue
if( n .lt. 5 ) go to 60
   40 mp1 = m + 1
do 50 i = mp1,n,5
  dtemp = dtemp + dx(i)*dy(i) + dx(i + 1)*dy(i + 1) + &
  dx(i + 2)*dy(i + 2) + dx(i + 3)*dy(i + 3) + dx(i + 4)*dy(i + 4)
   50 continue
   60 ddot = dtemp
return
end function ddot

!********************************************************************
integer function idamax(n,dx,incx)
!********************************************************************
! finds the index of element having max. absolute value.
! jack dongarra, linpack, 3/11/78.
! modified 3/93 to return if incx .le. 0.
! modified 12/3/93, array(1) declarations changed to array(*)
double precision dx(*),dmax
integer i,incx,ix,n
idamax = 0
if( n.lt.1 .or. incx.le.0 ) return
idamax = 1
if(n.eq.1)return
if(incx.eq.1)go to 20
! code for increment not equal to 1
ix = 1
dmax = dabs(dx(1))
ix = ix + incx
do 10 i = 2,n
   if(dabs(dx(ix)).le.dmax) go to 5
   idamax = i
   dmax = dabs(dx(ix))
    5    ix = ix + incx
   10 continue
return
! code for increment equal to 1
   20 dmax = dabs(dx(1))
do 30 i = 2,n
   if(dabs(dx(i)).le.dmax) go to 30
   idamax = i
   dmax = dabs(dx(i))
   30 continue
return
end function idamax


!********************************************************************
subroutine dswap(n,dx,incx,dy,incy)
!********************************************************************
! interchanges two vectors.
! uses unrolled loops for increments equal one.
! jack dongarra, linpack, 3/11/78.
! modified 12/3/93, array(1) declarations changed to array(*)
double precision dx(*),dy(*),dtemp
integer i,incx,incy,ix,iy,m,mp1,n
if(n.le.0)return
if(incx.eq.1.and.incy.eq.1)go to 20
! code for unequal increments or equal increments not equal to 1
ix = 1
iy = 1
if(incx.lt.0)ix = (-n+1)*incx + 1
if(incy.lt.0)iy = (-n+1)*incy + 1
do 10 i = 1,n
  dtemp = dx(ix)
  dx(ix) = dy(iy)
  dy(iy) = dtemp
  ix = ix + incx
  iy = iy + incy
   10 continue
return
! code for both increments equal to 1
! clean-up loop
   20 m = mod(n,3)
if( m .eq. 0 ) go to 40
do 30 i = 1,m
  dtemp = dx(i)
  dx(i) = dy(i)
  dy(i) = dtemp
   30 continue
if( n .lt. 3 ) return
   40 mp1 = m + 1
do 50 i = mp1,n,3
  dtemp = dx(i)
  dx(i) = dy(i)
  dy(i) = dtemp
  dtemp = dx(i + 1)
  dx(i + 1) = dy(i + 1)
  dy(i + 1) = dtemp
  dtemp = dx(i + 2)
  dx(i + 2) = dy(i + 2)
  dy(i + 2) = dtemp
   50 continue
return
end subroutine dswap

!-------------------------------------------------------------------------------------


    
end module statistics