

module wageproc

! module giving wage process given variance on
! permanent and transitory components

use params

implicit none

double precision  normen, norvar, stdevw, pnormen, pnorvar, pstdevw !,dnordf

double precision, allocatable :: contot(:,:,:,:,:)
double precision, allocatable ::  xw(:,:), yy(:), pyy(:)


double precision, allocatable :: pcumtrw(:)
double precision, allocatable :: trxw(:), ptrxw(:), cumtrw(:)
double precision, allocatable :: trweig(:), ptrweig(:), expvalue(:,:), expexpvalue(:,:)

double precision, allocatable, private :: absc(:), weig(:), sumprob(:), abscis(:), weigs(:)
double precision, allocatable, private :: pabscis(:), pweigs(:), trweigs(:), ptrweigs(:)
double precision, allocatable, private :: trabsc(:), ptrabsc(:),trwe(:), ptrwe(:), trabscis(:)
double precision, allocatable, private :: whigh(:), wlow(:), pwhigh(:), pwlow(:), ptrabscis(:)
double precision, allocatable, private :: pabsc(:), pweig(:), psumprob(:)

integer, allocatable :: dsolve(:,:,:,:,:), totdsolv(:,:)

integer, private :: i, ifail, irule, itype, jj, jl, jm, ju, nfix, p, pp, t, w, ww, wn, x

double precision, private :: aa, bb,   cconst, const2, dz,  hk, meanshk, qxfix(1),  &
    pweight, rhomult, sdz, summed, total, weight, xpri, sdzp, meanshkp ,  &
    aaint, bbint, errrel, errabs, errest, dzp, total2


double precision :: constinteg, expinteg, transw, transw1, transp, transp1, wagecorr, cconst1, cconst2, mid



!external dnordf

contains

    subroutine allocate_wageproc_perm( iret )
        implicit none
        integer, intent(out)    :: iret
        integer                             :: ier(5)

       

	allocate (contot(nw,pnw,nw,pnw,nt), &
                 xw(nw,maxntinp),  expvalue(noexp,maxntinp), &
                expexpvalue(noexp,maxntinp), yy(maxntinp), stat = ier(1) )

				

    allocate (dsolve(nw,pnw,nw,pnw,totlen), totdsolv(nw,pnw), stat = ier(2) )
	allocate ( pyy(maxntinp), stat = ier(3) )

      

        do i=1,3
            if ( ier(i) .ne. 0) then
                iret = -i
                return
            endif
        enddo

        iret = 0

    end subroutine allocate_wageproc_perm

    subroutine allocate_wageproc_temp( iret )
        implicit none
        integer, intent(out)    :: iret
        integer  :: ier(2)

        allocate (absc(nw), abscis(nw), weigs(nw), sumprob(nw), &
            whigh(maxntinp), wlow(maxntinp), weig(nw), stat = ier(1) )

        do i=1,2
            if ( ier(i) .ne. 0) then
                iret = -i
                return
            endif
        enddo

        iret = 0

    end subroutine allocate_wageproc_temp

    subroutine deallocate_wageproc_temp( iret )
        implicit none
        integer, intent(out)    :: iret
        integer  :: ier(2)

        deallocate (absc, abscis, weigs, sumprob, whigh, wlow, weig,stat = ier(1) )


        do i=1,2
            if ( ier(i) .ne. 0) then
                iret = -i
                return
            endif
        enddo

        iret = 0

    end subroutine deallocate_wageproc_temp



    subroutine allocate_partproc_temp( iret )
        implicit none
        integer, intent(out)    :: iret
        integer  :: ier(2)

        allocate (pabsc(pnw), pabscis(pnw), pweigs(pnw), psumprob(pnw), &
                pweig(pnw), pwlow(maxntinp), pwhigh(maxntinp), stat = ier(1) )


        do i=1,2
            if ( ier(i) .ne. 0) then
                iret = -i
                return
            endif
        enddo

        iret = 0

    end subroutine allocate_partproc_temp

    subroutine deallocate_partproc_temp( iret )
        implicit none
        integer, intent(out)    :: iret
        integer  :: ier(2)

        deallocate (pabsc, pabscis, pweigs, pweig, pwlow, pwhigh, sumprob, stat = ier(1) )

        deallocate (ptrabsc, ptrwe, ptrabscis, ptrweigs,  stat = ier(2) )

        do i=1,2
            if ( ier(i) .ne. 0) then
                iret = -i
                return
            endif
        enddo

        iret = 0

    end subroutine deallocate_partproc_temp


!_______________________________________________________________________
  subroutine markovwagepr

 

			!!!!1-----exogenous wage growth with age, husband
			
            do t=1,nt
                if(quarter==0)then 
                    age = 22 + t
			    else
			        age= 22 + (t-1)/4
			    endif
                pyy(t) = exp(  page1 * dble(age) + page2 * dble(age)**2 )
                
                
            enddo

			!!!!2-----human capital accumulation & exogenous wage growth with age, female
			!human capital (depends on values of calibrated parameters): can chage in the iterations
			!of the calibration
            
            do t=1,nt 
                if(quarter==0)then
                    age = 22 + t
			    else
			        age = 22 + (t-1)/4
			    endif
                            
                  if(noexp.lt.2)then
                    !exogenous growth for females also (same as male) 
                    yy(t) = exp(  age1 * dble(age) + age2 * dble(age)**2 )
                  
                  else
                    !endogenous growth for female wages through participation
                    yy(t) = 1.d0
                  endif
    
                  if (t.eq.frischt) then 
                    yy(t) = yy(t)*wagevar
                  endif
            enddo


            !!!!3-----grid for experience
			if(noexp.lt.2)then  
				expvalue=1.d0

			else

				do x =1,noexp
					expvalue(x,1) = inithk
				enddo
				do t=2,nt

					expvalue(1,t) = expvalue(1,t-1)*(1.d0 - deltaperF(expvalue(1,t-1)))
					expvalue(noexp,t) = humancap(t-1, expvalue(noexp,t-1), max(hours*hoursdecision,hoursfix) ) 
				
				
					cconst = (expvalue(noexp,t)-expvalue(1,t))*0.3d0/dble(noexp-6)
					
					do x =2,noexp-6
						expvalue(x,t) = expvalue(1,t) + cconst * dble(x-1)
					enddo
					
					do x =noexp-5,noexp-1
						expvalue(x,t) =expvalue(noexp-6,t) + (expvalue(noexp,t)- expvalue(noexp-6,t))*(x-noexp+6)/6.d0
					enddo
					
				enddo

			endif 
			

            if(nw.gt.1.and.pnw.gt.1)then
              
          
            do t=1,nt
 	            do w=1,nw
		            do p=1,pnw

						!now adjust because of probability of no -update
			            total2 = 0.d0 
                        do ww=1,nw
                            do pp=1,pnw
			                    
					            if(prob(ww,pp,w,p,t)<1.d-5)then
						                dsolve(ww,pp,w,p,t) = 0
										prob(ww,pp,w,p,t) = 0.d0 

						        else	
						                dsolve(ww,pp,w,p,t) = 1
						              	total2 = total2 + prob(ww,pp,w,p,t)
    					        endif


		                enddo !end pp
                        enddo !end ww

			            total = 0.d0 
                        do ww=1,nw
                            do pp=1,pnw
								prob(ww,pp,w,p,t) = prob(ww,pp,w,p,t)/total2
			                    total = total + prob(ww,pp,w,p,t)
			                    contot(ww,pp,w,p,t) = total
								
			                enddo !end pp
                        enddo !end ww

                   enddo !end p    
	            end do  !end w   
        enddo !end t

		do t=nt+1,nt+ret
			dsolve(:,:,:,:,t) = 1
		enddo
		
		else
		do t=1,nt
            absc(1) = 1.d0
            prob(1,1,1,1,t) = 1.d0
            contot(1,1,1,1,t) = 1.d0
            dsolve(1,1,1,1,t) = 1
        enddo
		
		endif  !nw,pnw>1
		

		

	!!!!HUSBAND WAGES: pxw may be read or calculated above, then we add the WAGE GROWTH here
    do t=1,nt

        if (pnw.gt.1) then
            do w=1,pnw
                
            
                    !divide by 2.71828d0*2000 since in WageGrid it was multiplied 
                    !by annual hours (2000)  and by 2.71828d0
                    
                    pxw3(w,t) = pyy(t)*meanearn*pxw2(w,t)*hoursfix/(2.71828d0*2000.d0)
         
        
                   
            enddo
        else

            pxw3(1,t) = meanearn*hoursfix*pyy(t)  
        
        endif
    enddo




	!!!!FEMALE WAGES: 
	!xww may be read or calculated above, then we add the WAGE GROWTH here & GENDER GAP
    !meanwage can change in the iterations of the calibration
    !!!meanwage = iniggap*pxw(max(pnw/2,1),1)/(expvalue(1,1)*hoursfix) 
    
    !multiply by meanearn as this was done for pxw in WageGrid.f90
    !multiply by iniggap to account for the offered wage gender gap 
	

   
   if(noexp.lt.2)then
        if(quarter.eq.1)meanwage = iniggap*meanearn
   else
        if(quarter.eq.1)meanwage = iniggap*meanearn*pyy(1)
   endif
    
   
	do t=1,maxntinp
		if (nw.gt.1) then
		
		!yy(t) is equal 1 if noexp>1
			do w=1,nw
				xw(w,t) = xww(w,t)*meanwage *yy(t)		
			enddo
		else
			xw(1,t) = meanwage *yy(t)
		
		endif
    enddo
	
	
	 do t=1,nt
	do w=1,pnw
		pxw(w,t)=pxw3(w,t) 
    enddo 
	enddo
	
	
 
  
    end subroutine markovwagepr


!__________________________________________________________________

double precision function humancap(hage, hkap, acthours)
integer hage, actualage
double precision hkap, loghumancap, acthours

    
    if(quarter.eq.0)then
        actualage = hage + 22
    else
        actualage  = (hage-1)/4 + 1 + 22
    endif
    
 
	loghumancap =  alpha1*log(hkap)+ log(1.d0 + oleta0 + oleta1*dble(hkap)  )
	
	humancap =  exp(loghumancap)

end function humancap
!__________________________________________________________________


integer function mapping(hage, xxxval, status, acthours)
integer hage, status, xxxval, xmin
double precision experien, acthours

        if (status.eq.0.and.xxxval.eq.1) then
                mapping = 1
        elseif (status.eq.1.and.xxxval.eq.noexp) then 
                mapping = noexp
        else

            if (status.eq.0) then
                experien = expvalue(xxxval,hage)*(1.d0 - deltaperF(expvalue(xxxval,hage)))
            else

                !*********** change here *********************************
				
                experien = humancap(hage, expvalue(xxxval,hage), acthours )

                !*********** change here *********************************
            endif

                        jl=0
                        ju=noexp+1
9812                    if (ju-jl.gt.1) then
                                jm = (ju+jl)/2
                                if (experien.gt.expvalue(jm,hage+1) ) then
                                    jl = jm
                                else
                                    ju = jm
                                endif
                                goto 9812
                        endif
                        xmin = jl
                        !if (xmin.eq.noexp) then
                        !    xmin = noexp - 1
                        !elseif (xmin.eq.0) then
                        !    xmin = 1
                        !endif
						mapping = xmin
						!it is possible to have mapping=0, this will be considered as a possible case in empfun & unempfun
						!In the rest of places where mapping is called &  mapping=0 will be substituted by mapping=1

         endif

end function

	
end module wageproc



