clear matrix
clear
set more off
capture log close

log using elasticities.log,replace

u sample.dta




keep if age>=25 & age<=55


gen phi=0.76
gen theta=1.75
gen gamma=2.07


gen Ml=(phi*wage*hours-cons)/(theta*cons + phi*wage*leis) if stat==1
gen Mh=-Ml*leis/hours

gen y=cons+wage*leis
gen term2=-phi*wage*leis/cons - theta
gen Il=-y*phi/(cons*term2)
gen Hl=Ml - Il*hours*wage/y
gen Hl2=-cons/(theta*cons + phi*wage*leis) if stat==1

gen Hh=-Hl*leis/hours
gen Hh2=-Hl2*leis/hours

gen c1=cons^(1-phi)
gen l1=leis^(1-theta)
gen M=c1/(1-phi) + alfa*l1/(1-theta)
gen Fl=(-alfa*gamma*c1 + M*phi)/(gamma*phi*(1-alfa)*l1 + alfa*theta*gamma*c1 + M*phi*theta)
gen Fh=-Fl*leis/hours



sum Mh,d

sum Fh,d

sum Hh,d

sum Hh2,d

clear





log close

*end























