clear
capture log close

log using lumpsum-VARwh.log,replace


u sample

keep if t<=160


gen x=1/(1+0.0037)

gen xbar=(1-x^160)/(1-x)


gen compt=0
*replace compt=(wage*0.1*leis)
replace compt=(wage*0.1*hours) 


preserve
collapse compt,by(age)
line compt age, ytitle("compensation") xtitle("") legend(off)   xlab(25 30 35 40 45 50  55 60 65, labsize(3))  title("", size(small)) graphregion( color(white )  ) saving(comp, replace)

graph export compensation.pdf,replace
restore

replace compt=compt*(x^(t-1)) 

sort i t
by i:egen PVcomp=sum(compt)

replace PVcomp=PVcomp/xbar


keep if t==1



***********************************
*SAME TRANSFER FOR EVERYBODY
***********************************

sum PVcomp

****************************************************************
*TRANSFER DIFFERS BY INITIAL WAGE
****************************************************************


egen p25 = pctile(wage)      if t==1, p(25)
egen p50 = pctile(wage) if t==1, p(50)
egen p75 = pctile(wage) if t==1, p(75)

gen perw=1 if wage<p25 &  t==1
replace perw=2 if wage>=p25 & wage<p50 &  t==1
replace perw=3 if wage>=p50 & wage<p75 &  t==1
replace perw=4 if wage>=p75 &  t==1

table perw,c(mean PVcomp)

drop p25 p50 p75



**********************************************************************
*TRANSFER DIFFERS BY INITIAL WAGE, INITIAL HUSBAND AND MATERNITY GROUP
**********************************************************************
gen mater=1     if agekid==-11
replace mater=2 if agekid==1
replace mater=3 if agekid==9
replace mater=4 if agekid==17
replace mater=5 if agekid==25
replace mater=6 if agekid==33
replace mater=7 if agekid==41
replace mater=8 if agekid==49
replace mater=9 if agekid==3997




egen p25 = pctile(part)      if t==1, p(25)
egen p50 = pctile(part) if t==1, p(50)
egen p75 = pctile(part) if t==1, p(75)

gen perp=1 if part<p25 &  t==1
replace perp=2 if part>=p25 & part<p50 &  t==1
replace perp=3 if part>=p50 & part<p75 &  t==1
replace perp=4 if part>=p75 &  t==1


table mater,c(mean PVcomp count PVcomp)


table perw perp,c(mean PVcomp)


gen type=(perp-1)*4*9 + (perw-1)*9 + mater

gen type2=(perp-1)*4 + perw

table type,c(mean PVcomp count PVcomp)

table type2 mater,c(mean PVcomp count PVcomp)


table type2,c(mean PVcomp count PVcomp)

log close


*end

