clear matrix
clear
set more off
capture log close

*i,agekid,hit,t+nt,0,0,stat,assterm,part,partcash,wage,cons,leis,alfa,alfad(t+nt),euler,1.d0

infile i agekid hit t expval yr stat asset part partcash wage cons leis ialfa alfa euler mrs using sample0000.out

compress

*****************************************************************************************************
*****************************************************************************************************
*****************************************************************************************************
*NEW VARIABLES
*****************************************************************************************************
*****************************************************************************************************
*****************************************************************************************************

gen agekid2=agekid+8

gen age=int((t-1)/4)+22

gen hours=1300-leis 
gen lpart=log(part)

gen obswage=wage if stat==1 
gen obshours=hours if stat==1
gen lobswage=log(obswage)
gen wagesp=part/550

gen lwage=log(wage)
gen lwagesp=log(wagesp)
gen lcons=log(cons)
gen lleis=log(leis) if stat==1


gen years1=(t-1)/4  - (agekid-1)/4
gen years2=(t-1)/4  - (agekid+8-1)/4

gen child02=0
gen child315=0
gen child1517=0

replace child02   =1 if years1>=0 & years1<3
replace child315  =1 if years1>=3 & years1<16
replace child1517 =1 if years1>=16 & years1<18


replace child02    =child02   +1 if years2>=0 & years2<3
replace child315   =child315  +1 if years2>=3 & years2<16
replace child1517  =child1517 +1 if years2>=16 & years2<18

gen child=child02+child315+child1517


gen size=2
replace size=size + 1 if years1>=0 & years1<19
replace size=size + 1 if years2>=0 & years2<19


gen lsize=log(size)

gen age2=age*age
gen age3=age*age*age

sort i t
by i:gen lagstat=stat[_n-3]


gen ofwage=wage

gen lofwage=log(ofwage)
replace lobswage=lobswage

*replace obshours=. if obshours<4

gen yr2=yr^2


gen inc=part+wage*hours if stat==1
replace inc=part if stat==0

gen Imot02=1 if ((t-agekid<=12 & t-agekid>=0)  | (t-agekid2<=12 & t-agekid2>=0))
gen Imot317=1 if (((t-agekid<=68 & t-agekid>12)  | (t-agekid2<=68 & t-agekid2>12)) & Imot02==.)
gen Inomot=1 if (Imot02==. & Imot317==.)


gen Imot02stat=stat if ((t-agekid<=12 & t-agekid>=0)  | (t-agekid2<=12 & t-agekid2>=0))
gen Imot317stat=stat if (((t-agekid<=68 & t-agekid>12)  | (t-agekid2<=68 & t-agekid2>12)) & Imot02==.)
gen Inomotstat=stat if (Imot02==. & Imot317==.)




*t=17 in the model is 26 years old
gen Imotyoungstat=stat if agekid<=17
gen Imotoldstat=stat if agekid>17




save sample.dta,replace





*end