clear matrix
clear
set more off
capture log close




*`j3': SCENARIO(0-NORMAL TIMES,1-RECESSION OR 2-BOOM)
*`j2': SIZE OF WAGE CHANGE (2 (1%),3 (5%), 4 (10%))
*`edad': age at which the bust/boom is created
*`q': quarter


*READ BASELINE FOR EACH AGE**********************************************************************************************

forval j3=1/1{
forval edad=25/55 {
*****i t expval yr stat asset part partcash wage cons leis alfa euler
infile i agekid hit t expval00 yr00 stat00 asset00 part00 partcash00 wage00 cons00 leis00 ialfa00 alfa00 euler00 mrs00 using sample`edad'`j3'.out

gen hours00=1300-leis00 

keep i t stat00 hours00 wage00 part00
save dB`edad'`j3'.dta,replace

clear

}
}





*COMPUTE ELASTICITIES***************************************************************************


forval j3=1/1{

forval j2=4/4{

forval edad=25/55{
forval q=1/4{




*i,t,yrsexp,stat,asset,part,partcash,wage,cons,leis alpha
infile i agekid hit t stat part wage leis alfa  using sample`edad'`q'`j2'`j3'.out

keep if t==(`edad'-22)*4 +`q'

gen hours=1300-leis

merge 1:1 i t  using dB`edad'`j3'.dta

keep if t==(`edad'-22)*4 +`q'

gen age=`edad'
gen quarter=`q'



log using f`edad'`q'`j2'`j3'.log,replace

gen lhours=log(hours)
gen lhours00=log(hours00)


sum hours00 hours,det
sum hours00 if stat00==1,det
sum hours if stat==1,det

egen awage=mean(wage)
egen awage00=mean(wage00)
gen ldeltaw=log(awage)-log(awage00)
sum ldeltaw

*EXTENSIVE MARGIN ELASTICITY
display "Extensive Margin Elasticity"
egen astat=mean(stat)
egen astat00=mean(stat00)
gen extelast=(astat-astat00)/0.1



gen agekidind=1 if agekid>100
replace agekidind=2 if agekid==5
replace agekidind=3 if agekid==25


forval k=1/3{

egen astatk`k'=mean(stat) if agekidind==`k'
egen astat00k`k'=mean(stat00)  if agekidind==`k'
gen extelastk`k'=(astatk`k'-astat00k`k')/0.1  if agekidind==`k'

}


*AGGREGATE CHANGE IN HOURS (INCLUDING NON PARTICIPANTS)
display "Aggregate Change in Hours, including non participants"
egen ahours=mean(hours)
egen ahours00=mean(hours00)
gen macroelast=(ahours/ahours00-1)/0.1 


*EFFICIENTY UNITS CHANGE
display "Aggregate Change in Gross Earnings"
gen earn00=hours00*wage00
gen earn=hours*wage00
egen aearn=mean(earn) 
egen aearn00=mean(earn00)
gen aggearn=(aearn/aearn00-1)/0.1


*INTENSIVE MARGIN (INDIVIDUAL HOURS VARIATION CONDITIONING ON WORKING IN BOTH PERIODS)
display "Intensive Margin Elasticity"
gen diflhoursi=(hours/hours00-1)/0.1  if stat==1 & stat00==1 


sum extelast
gen e=r(mean)

sum extelastk1
gen e1=r(mean)

sum extelastk2
gen e2=r(mean)

sum extelastk3
gen e3=r(mean)

sum macroelast
gen m=r(mean)

sum aggearn
gen eff=r(mean)

sum diflhoursi,det
gen h25=r(p25)
gen h50=r(p50)
gen h75=r(p75)


keep if i==1


keep t age quarter e e1 e2 e3 h25 h50 h75 m eff
save  elastage`edad'`q'.dta,replace


clear

log close


}
}
}
}




*******************************************************************************************************************************
forval j3=1/1{
forval j2=4/4{

u elastage251.dta
append using elastage252.dta
append using elastage253.dta
append using elastage254.dta

forval edad=26/55{

forval q=1/4{

append using elastage`edad'`q'

}


}
gen var=`j2'
gen cycle=`j3'
save elast`j2'`j3',replace
clear
}
}


*********************************************************************************************************************************

u elast41

gen edad=age+(t-(age-22)*4)/4

gen ageg=1 if edad>=25 & edad<30
replace ageg=2 if edad>=30 & edad<35
replace ageg=3 if edad>=35 & edad<40
replace ageg=4 if edad>=40 & edad<45
replace ageg=5 if edad>=45 & edad<50
replace ageg=6 if edad>=50 & edad<55

log using bust.log,replace
table ageg,c(mean e mean h25 mean h50 mean h75 mean m)


log close

*end














