clear matrix
clear
set more off
capture log close
set mem 200m


u mergesample.dta,replace


log using elast-mhetero.log,replace





forval q=1/4{

preserve 

keep if percentil==`q'







sum hours00 hours,det
sum hours00 if stat00==1,det
sum hours if stat==1,det


sum part

egen awage=mean(wage)
egen awage00=mean(wage00)
gen ldeltaw=log(awage)-log(awage00)
sum ldeltaw



*EXTENSIVE MARGIN ELASTICITY
display "Extensive Margin Elasticity"
egen astat=mean(stat)  if age>=25 & age<=55
egen astat00=mean(stat00)  if age>=25 & age<=55
*gen extelast=(astat-astat00)/ldeltaw
gen extelast=(astat-astat00)/0.1




*AGGREGATE CHANGE IN HOURS (INCLUDING NON PARTICIPANTS)
display "Aggregate Change in Hours, including non participants"
egen ahours=mean(hours)  if age>=25 & age<=55
egen ahours00=mean(hours00)  if age>=25 & age<=55
*gen macroelast=(log(ahours)-log(ahours00))/ldeltaw 
gen macroelast=(ahours/ahours00-1)/0.1

*EFFICIENTY UNITS CHANGE
gen earn00=hours00*wage00
gen earn=hours*wage00
egen aearn=mean(earn) if age>=25 & age<=55
egen aearn00=mean(earn00) if age>=25 & age<=55
*gen aggearn=(log(aearn)-log(aearn00))/ldeltaw
gen aggearn=(aearn/aearn00-1)/0.1




*INTENSIVE MARGIN (INDIVIDUAL HOURS VARIATION CONDITIONING ON WORKING IN BOTH PERIODS)
display "Intensive Margin Elasticity"
*gen diflhoursi=(lhours-lhours00)/ldeltaw  if stat==1 & stat00==1 
gen diflhoursi=(hours/hours00-1)/0.1  if stat==1 & stat00==1 




sum extelast* macroelast* aggearn
sum diflhoursi  if age>=25 & age<=55,det


restore

}



log close






*end














